<?php
/***********************************************************************

  Copyright (C) 2002, 2003  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


// This script updates the forum database to version 1.1.4.
// Copy this file to the forum root directory and run it. Then remove it from
// the root directory.


$update_from = array('1.1', '1.1.1', '1.1.2', '1.1.3');
$update_to = '1.1.4';


$pun_root = './';
@include $pun_root.'config.php';

// If PUN isn't defined, config.php is missing or corrupt or we are outside the root directory
if (!defined('PUN'))
	exit('This file must be run from the forum root directory.');

// Enable debug mode
define('PUN_DEBUG', 1);

// Disable error reporting for uninitialized variables
error_reporting(E_ERROR | E_WARNING | E_PARSE);

// Turn off magic_quotes_runtime
set_magic_quotes_runtime(0);

// Turn off PHP time limit
@set_time_limit(0);


// Load the functions script
require $pun_root.'include/functions.php';


// Load DB abstraction layer and try to connect
require $pun_root.'include/dblayer/common_db.php';


// Check current version
$result = $db->query('SELECT conf_value FROM '.$db->prefix.'config WHERE conf_name=\'o_cur_version\'');
if (!$result || !in_array($db->result($result, 0), $update_from))
	error('Version mismatch. This script updates version '.implode(' and ', $update_from).' to version '.$update_to.'. The database \''.$db_name.'\' doesn\'t seem to be running a supported version', __FILE__, __LINE__);


// This feels like a good time to update lastpost/lastposter for all forums
$result = $db->query('SELECT id FROM '.$db->prefix.'forums') or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());

while ($row = $db->fetch_row($result))
	update_forum($row[0]);


// We'll empty the search results table as well
$db->query('TRUNCATE TABLE '.$db->prefix.'search_results') or error('Unable to flush search results', __FILE__, __LINE__, $db->error());


// Update version information in database
$db->query('UPDATE '.$db->prefix."config SET conf_value='".$update_to."' WHERE conf_name='o_cur_version'") or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());


exit('Update successful! Your forum database has now been updated to version '.$update_to.'. You should now remove this script from the forum root directory.');
