<?php
/***********************************************************************

  Copyright (C) 2002, 2003, 2004  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


$pun_root = './';
require $pun_root.'include/common.php';
require $pun_root.'include/common_admin.php';


if ($cur_user['status'] < PUN_MOD)
	message($lang_common['No permission']);


// Add/edit a ban (stage 1)
if (isset($_REQUEST['add_ban']) || isset($_GET['edit_ban']))
{
	if (isset($_GET['add_ban']) || isset($_POST['add_ban']))
	{
		// If the id of the user to ban was provided through GET (a link from profile.php)
		if (isset($_GET['add_ban']))
		{
			$add_ban = intval($_GET['add_ban']);
			if (empty($add_ban))
				message($lang_common['Bad request']);

			$user_id = $add_ban;

			$result = $db->query('SELECT username, email, status FROM '.$db->prefix.'users WHERE id='.$user_id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
			if ($db->num_rows($result))
				list($ban_user, $ban_email, $user_status) = $db->fetch_row($result);
			else
				message('No user by that ID registered.');
		}
		else	// Otherwise the username is in POST
		{
			$ban_user = trim($_POST['new_ban_user']);
	
			if ($ban_user != '')
			{
				$result = $db->query('SELECT id, username, email, status FROM '.$db->prefix.'users WHERE username=\''.escape($ban_user).'\'') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
				if ($db->num_rows($result))
					list($user_id, $ban_user, $ban_email, $user_status) = $db->fetch_row($result);
				else
					message('No user by that username registered. If you want to add a ban not tied to a specific username just leave the username blank.');
			}
		}

		// Make sure we're not banning an admin
		if ($user_status == PUN_ADMIN)
			message('The user '.pun_htmlspecialchars($ban_user).' is an administrator and can\'t be banned. If you want to ban an administrator, you must first demote him/her to moderator or user.');

		// If we have a $user_id, we can try to find the last known IP of that user
		if (isset($user_id))
		{
			$result = $db->query('SELECT poster_ip FROM '.$db->prefix.'posts WHERE poster_id='.$user_id.' ORDER BY posted DESC LIMIT 1') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
			$ban_ip = ($db->num_rows($result)) ? $db->result($result, 0) : '';
		}

		$ban_message = '';
		$mode = 'add';
	}
	else	// We are editing a ban
	{
		$ban_id = intval($_GET['edit_ban']);
		if (empty($ban_id))
			message($lang_common['Bad request']);

		$result = $db->query('SELECT username, ip, email, message, expire FROM '.$db->prefix.'bans WHERE id='.$ban_id) or error('Unable to fetch ban info', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
			list($ban_user, $ban_ip, $ban_email, $ban_message, $ban_expire) = $db->fetch_row($result);
		else
			message($lang_common['Bad request']);

		$ban_expire = ($ban_expire != '') ? format_time($ban_expire, true) : '';

		$mode = 'edit';
	}

	$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / Admin / Bans';
	$form_name = 'bans2';
	$focus_element = 'ban_user';
	require $pun_root.'header.php';

	if ($cur_user['status'] == PUN_MOD)
		moderator_menu('bans');
	else
		admin_menu('bans');


?>
<form method="post" action="admin_bans.php" id="bans2">
	<input type="hidden" name="mode" value="<?php echo $mode ?>">
	<input type="hidden" name="ban_id" value="<?php echo $ban_id ?>">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2">Supplement ban with IP and e-mail</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap">IP and e-mail&nbsp;&nbsp;</td>
			<td class="puncon2">
				<table class="punplain" cellpadding="6">
					<tr>
						<td class="punright" style="width: 35%"><b>Username</b><br>The username to ban.</td>
						<td style="width: 35%"><input type="text" name="ban_user" size="25" maxlength="25" value="<?php echo pun_htmlspecialchars($ban_user) ?>" tabindex="1"></td>
					</tr>
					<tr>
						<td class="punright" style="width: 35%"><b>IP-adresses</b><br>The IP or IP-ranges you wish to ban (e.g. 150.11.110.1 or 150.11.110). Separate addresses with spaces. If an IP is entered already it is the last known IP of this user in the database.<?php if ($ban_user != '') echo ' Click <a href="admin_users.php?ip_stats='.$user_id.'">here</a> to see IP statistics for this user.' ?></td>
						<td style="width: 35%"><input type="text" name="ban_ip" size="45" maxlength="255" value="<?php echo $ban_ip ?>" tabindex="2"></td>
						<td class="puncent" style="width: 30%" rowspan="2"><input type="submit" name="add_edit_ban" value="Submit" tabindex="6"></td>
					</tr>
					<tr>
						<td class="punright" style="width: 35%"><b>E-mail/domain</b><br>The e-mail or e-mail domain you wish to ban (e.g. someone@somewhere.com or somewhere.com). See "Allow banned e-mail addresses" in Options for more info.</td>
						<td style="width: 35%"><input type="text" name="ban_email" size="40" maxlength="50" value="<?php echo strtolower($ban_email) ?>" tabindex="3"></td>
					</tr>
					<tr>
						<td class="punright" style="width: 35%"><b>Ban message</b><br>A message that will be displayed to the banned user when he/she visits the forums.</td>
						<td style="width: 35%"><input type="text" name="ban_message" size="50" maxlength="255" value="<?php echo $ban_message ?>" tabindex="4"></td>
					</tr>
					<tr>
						<td class="punright" style="width: 35%"><b>Expire date</b><br>The date when this ban should be automatically removed (format: YYYY-MM-DD). Leave blank to remove manually.</td>
						<td style="width: 35%"><input type="text" name="ban_expire" size="17" maxlength="10" value="<?php echo $ban_expire ?>" tabindex="5"></td>
					</tr>
					<tr>
						<td colspan="3">You should be very careful when banning an IP-range because of the possibility of multiple users matching the same partial IP.</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

	require $pun_root.'footer.php';
}


// Add/edit a ban (stage 2)
else if (isset($_POST['add_edit_ban']))
{
	confirm_referer('admin_bans.php');

	$ban_user = $_POST['ban_user'];
	$ban_ip = trim($_POST['ban_ip']);
	$ban_email = strtolower(trim($_POST['ban_email']));
	$ban_message = trim($_POST['ban_message']);
	$ban_expire = trim($_POST['ban_expire']);

	if ($ban_user == '' && $ban_ip == '' && $ban_email == '')
		message('You must enter either a username, an IP address or an e-mail address (at least).');

	// Validate IP/IP range (it's overkill, I know)
	if ($ban_ip != '')
	{
		$ban_ip = preg_replace('/[\s]{2,}/', ' ', $ban_ip);
		$addresses = explode(' ', $ban_ip);
		$addresses = array_map('trim', $addresses);

		for ($i = 0; $i < count($addresses); ++$i)
		{
			$octets = explode('.', $addresses[$i]);

			for ($c = 0; $c < count($octets); ++$c)
			{
				$octets[$c] = (strlen($octets[$c]) > 1) ? ltrim($octets[$c], "0") : $octets[$c];

				if ($c > 3 || preg_match('/[^0-9]/', $octets[$c]) || intval($octets[$c]) > 255)
					message('You entered an invalid IP/IP-range.');
			}

			$cur_address = implode('.', $octets);
			$addresses[$i] = $cur_address;
		}

		$ban_ip = implode(' ', $addresses);
	}

	require $pun_root.'include/email.php';
	if ($ban_email != '' && !is_valid_email($ban_email))
	{
		if (!preg_match('/^[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$/', $ban_email))
			message('The e-mail address (e.g. user@domain.com) or partial e-mail address domain (e.g. domain.com) you entered is invalid.');
	}

	if ($ban_expire != '' && $ban_expire != 'Never')
	{
		$ban_expire = strtotime($ban_expire);

		if ($ban_expire == -1 || $ban_expire <= time())
			message('You entered an invalid expire date. The format should be YYYY-MM-DD and the date must be at least one day in the future.');
	}
	else
		$ban_expire = 'NULL';

	$ban_user = ($ban_user != '') ? '\''.escape($ban_user).'\'' : 'NULL';
	$ban_ip = ($ban_ip != '') ? '\''.escape($ban_ip).'\'' : 'NULL';
	$ban_email = ($ban_email != '') ? '\''.escape($ban_email).'\'' : 'NULL';
	$ban_message = ($ban_message != '') ? '\''.escape($ban_message).'\'' : 'NULL';

	if ($_POST['mode'] == 'add')
		$db->query('INSERT INTO '.$db->prefix.'bans (username, ip, email, message, expire) VALUES('.$ban_user.', '.$ban_ip.', '.$ban_email.', '.$ban_message.', '.$ban_expire.')') or error('Unable to add ban', __FILE__, __LINE__, $db->error());
	else
		$db->query('UPDATE '.$db->prefix.'bans SET username='.$ban_user.', ip='.$ban_ip.', email='.$ban_email.', message='.$ban_message.', expire='.$ban_expire.' WHERE id='.$_POST['ban_id']) or error('Unable to add ban', __FILE__, __LINE__, $db->error());

	redirect('admin_bans.php', 'Ban added. Redirecting ...');
}


// Remove a ban
else if (isset($_GET['del_ban']))
{
	confirm_referer('admin_bans.php');

	$ban_id = intval($_GET['del_ban']);
	if (empty($ban_id))
		message($lang_common['Bad request']);

	$db->query('DELETE FROM '.$db->prefix.'bans WHERE id='.$ban_id) or error('Unable to delete ban', __FILE__, __LINE__, $db->error());

	redirect('admin_bans.php', 'Ban removed. Redirecting ...');
}


$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / Admin / Bans';
$form_name = 'bans';
$focus_element = 'new_ban_user';
require $pun_root.'header.php';

if ($cur_user['status'] > 1)
	admin_menu('bans');
else
	moderator_menu('bans');

?>
<form method="post" action="admin_bans.php?action=more" id="bans">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2">New ban</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap">Add ban&nbsp;&nbsp;</td>
			<td class="puncon2">
				<table class="punplain" cellpadding="6">
					<tr>
						<td class="punright" style="width: 35%"><b>Username</b><br>The username to ban (case insensitive). The next page will let you enter a custom IP and e-mail. If you just want to ban a specific IP/IP-range or e-mail just leave it blank.</td>
						<td style="width: 35%"><input type="text" name="new_ban_user" size="25" maxlength="25"></td>
						<td style="width: 30%"><input type="submit" name="add_ban" value=" Add "></td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead" style="width: 11%; white-space: nowrap">Username</td>
		<td class="punhead" style="width: 19%; white-space: nowrap">E-mail</td>
		<td class="punhead" style="width: 22%; white-space: nowrap">IP/IP-ranges</td>
		<td class="punhead" style="width: 27%; white-space: nowrap">Reason</td>
		<td class="punhead" style="width: 9%; white-space: nowrap">Expires</td>
		<td class="punhead" style="white-space: nowrap">Actions</td>
	</tr>
<?php

$result = $db->query('SELECT id, username, ip, email, message, expire FROM '.$db->prefix.'bans ORDER BY id') or error('Unable to ban list', __FILE__, __LINE__, $db->error());
if ($db->num_rows($result))
{
	while ($cur_ban = $db->fetch_assoc($result))
	{
		$expire = format_time($cur_ban['expire'], true);

?>
	<tr class="puncon2">
		<td><?php echo ($cur_ban['username'] != '') ? pun_htmlspecialchars($cur_ban['username']) : '-' ?></td>
		<td><?php echo ($cur_ban['email'] != '') ? $cur_ban['email'] : '-' ?></td>
		<td><?php echo ($cur_ban['ip'] != '') ? $cur_ban['ip'] : '-' ?></td>
		<td><?php echo ($cur_ban['message'] != '') ? $cur_ban['message'] : '-' ?></td>
		<td><?php echo $expire ?></td>
		<td><a href="admin_bans.php?edit_ban=<?php echo $cur_ban['id'] ?>">Edit</a> - <a href="admin_bans.php?del_ban=<?php echo $cur_ban['id'] ?>">Remove</a></td>
	</tr>
<?php

	}
}
else
	echo "\t".'<tr class="puncon2"><td colspan="6">No bans in list.</td></tr>'."\n";

?>
</table>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

require $pun_root.'footer.php';
