<?php
/***********************************************************************

  Copyright (C) 2002, 2003, 2004  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


$pun_root = './';
require $pun_root.'include/common.php';


if ($cookie['is_guest'] && $pun_config['p_guests_read'] == '0')
	message($lang_common['Login required']);

// Load the post.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_post.php';

if (isset($_POST['form_sent']))
{
	// Flood protection
	if ($cur_user['status'] < PUN_MOD && $cur_user['last_post'] != '' && (time() - $cur_user['last_post']) < $pun_config['o_flood_interval'])
		message($lang_post['Flood start'].' '.$pun_config['o_flood_interval'].' '.$lang_post['flood end']);

	// Make sure form_user is correct
	if (($cookie['is_guest'] && $_POST['form_user'] != 'Guest') || (!$cookie['is_guest'] && unescape($_POST['form_user']) != $cur_user['username']))
		message($lang_common['Bad request']);

	$smilies = $_POST['smilies'];

	// If it's a reply
	if (isset($_GET['tid']))
	{
		$tid = intval($_GET['tid']);
		if (empty($tid))
			message($lang_common['Bad request']);

		if (($pun_config['p_guests_post'] == '0' && $cookie['is_guest']) || ($pun_config['p_users_post'] == '0' && $cur_user['status'] < PUN_MOD))
			message($lang_common['No permission']);

		$result = $db->query('SELECT closed, forum_id FROM '.$db->prefix.'topics WHERE id='.$tid) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
		if (!$db->num_rows($result))
			message($lang_common['Bad request']);

		list($closed, $forum_id) = $db->fetch_row($result);

		$forum_closed = '0';
		if (!is_admmod($forum_id, $forum_closed, $admmod_only))
		{
			if (($admmod_only == '1' && $cur_user['status'] < PUN_MOD) || ($closed == '1' || $forum_closed == '1'))
				message($lang_common['No permission']);
		}
	}
	// If it's a new topic
	else if (isset($_GET['fid']))
	{
		$fid = intval($_GET['fid']);
		if (empty($fid))
			message($lang_common['Bad request']);

		if (($pun_config['p_guests_post_topic'] == '0' && $cookie['is_guest']) || ($pun_config['p_users_post_topic'] == '0' && $cur_user['status'] < PUN_MOD))
			message($lang_common['No permission']);

		$result = $db->query('SELECT moderators, admmod_only, closed FROM '.$db->prefix.'forums WHERE id='.$fid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
		if (!$db->num_rows($result))
			message($lang_common['Bad request']);

		list($moderators, $admmod_only, $forum_closed) = $db->fetch_row($result);
		$mods_array = ($moderators != '') ? unserialize($moderators) : array();

		if (($admmod_only == '1' && $cur_user['status'] < PUN_MOD) || ($forum_closed == '1' && $cur_user['status'] < PUN_ADMIN && !array_key_exists($cur_user['username'], $mods_array)))
			message($lang_common['No permission']);

		$subject = trim(unescape($_POST['req_subject']));
		if ($subject == '')
			message($lang_post['No subject']);
		else if (pun_strlen($subject) > 70)
			message($lang_post['Too long subject']);
		else if ($pun_config['p_subject_all_caps'] == '0' && strtoupper($subject) == $subject && $cur_user['status'] < PUN_MOD)
			message($lang_post['No caps subject']);
	}
	else
		message($lang_common['Bad request']);


	// If the user is logged in we get the username and e-mail from $cur_user
	if (!$cookie['is_guest'])
	{
		$username = $cur_user['username'];
		$email = $cur_user['email'];
	}
	// Otherwise it should be in $_POST
	else
	{
		$username = trim(unescape($_POST['req_username']));
		$email = strtolower(trim($_POST['req_email']));

		// Load the register.php/profile.php language files
		require $pun_root.'lang/'.$language.'/'.$language.'_prof_reg.php';
		require $pun_root.'lang/'.$language.'/'.$language.'_register.php';

		// It's a guest, so we have to validate the username
		if (strlen($username) < 2)
			message($lang_prof_reg['Username too short']);
		else if (!strcasecmp($username, 'Guest') || !strcasecmp($username, $lang_common['Guest']))
			message($lang_prof_reg['Username guest']);
		else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
			message($lang_prof_reg['Username IP']);
		else if ((strpos($username, '[') !== false || strpos($username, ']') !== false) && strpos($username, '\'') !== false && strpos($username, '"') !== false)
			message($lang_prof_reg['Username reserved chars']);
		else if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
			message($lang_prof_reg['Username BBCode']);

		// Check username for any censored words
		$temp = censor_words($username);
		if ($temp != $username)
			message($lang_register['Username censor']);


		// Check that the username (or a too similar username) is not already registered
		$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE username=\''.addslashes($username).'\' OR username=\''.addslashes(preg_replace("/[^\w]/", '', $username)).'\'') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());

		if ($db->num_rows($result))
		{
			$busy = $db->result($result, 0);
			message($lang_register['Username dupe 1'].' '.pun_htmlspecialchars($busy).'. '.$lang_register['Username dupe 2']);
		}


		require $pun_root.'include/email.php';

		if (!is_valid_email($email))
			message($lang_common['Invalid e-mail']);
	}

	// Clean up message from POST
	$message = pun_linebreaks(trim(unescape($_POST['req_message'])));


	if ($message == '')
		message($lang_post['No message']);
	else if (strlen($message) > 65535)
		message($lang_post['Too long message']);
	else if ($pun_config['p_message_all_caps'] == '0' && strtoupper($message) == $message && $cur_user['status'] < PUN_MOD)
		message($lang_post['No caps message']);


	// Validate BBCode syntax
	if ($pun_config['p_message_bbcode'] == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false)
	{
		// Change all BBCodes to lower case (this way a lot of regex searches can be case sensitive)
		$a = array('[B]', '[I]', '[U]', '[/B]', '[/I]', '[/U]');
		$b = array('[b]', '[i]', '[u]', '[/b]', '[/i]', '[/u]');
		$message = str_replace($a, $b, $message);

		$a = array("#\[quote\]#i", "#\[quote=#i", "#\[/quote\]#i", "#\[code\]#i", "#\[/code\]#i", "#\[colou?r=([a-zA-Z]*|\#?[0-9a-fA-F]{6})\]#i", "#\[/colou?r\]#i", "#\[img\]#i", "#\[/img\]#i", "#\[email\]#i", "#\[email=#i", "#\[/email\]#i", "#\[url\]#i", "#\[url=#i", "#\[/url\]#i");
		$b = array('[quote]', '[quote=', '[/quote]', '[code]', '[/code]', "[color=\\1]", '[/color]', '[img]', '[/img]', '[email]', '[email=', '[/email]', '[url]', '[url=', '[/url]');
		$message = preg_replace($a, $b, $message);

		require $pun_root.'include/parser.php';
		if ($overflow = check_tag_order($message))
			// The quote depth level was too high, so we strip out the inner most quote(s)
			$message = substr($message, 0, $overflow[0]).substr($message, $overflow[1], (strlen($message) - $overflow[0]));
	}


	if ($smilies != '1') $smilies = '0';

	$now = time();
	require $pun_root.'include/search_idx.php';

	// If it's a reply
	if (isset($_GET['tid']))
	{
		// Get the topic subject
		$result = $db->query('SELECT subject FROM '.$db->prefix.'topics WHERE id='.$tid) or error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
		$subject = $db->result($result, 0);

		if (!$cookie['is_guest'])
		{
			// Insert the new post (start transaction)
			$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_id, poster_ip, message, smilies, posted, topic_id) VALUES(\''.addslashes($username).'\', '.$cur_user['id'].', \''.get_remote_address().'\', \''.addslashes($message).'\', \''.$smilies.'\', '.$now.', '.$tid.')', PUN_TRANS_START) or error('Unable to create post', __FILE__, __LINE__, $db->error());
			$new_pid = $db->insert_id();

			// To subscribe or not to subscribe, that ...
			if ($pun_config['o_subscriptions'] == '1' && $_POST['subscribe'] == '1')
			{
				$result = $db->query('SELECT 1 FROM '.$db->prefix.'subscriptions WHERE user_id='.$cur_user['id'].' AND topic_id='.$tid) or error('Unable to fetch subscription info', __FILE__, __LINE__, $db->error());
				if (!$db->num_rows($result))
					$db->query('INSERT INTO '.$db->prefix.'subscriptions (user_id, topic_id) VALUES('.$cur_user['id'].' ,'.$tid.')') or error('Unable to add subscription', __FILE__, __LINE__, $db->error());
			}
		}
		else
		{
			// It's a guest. Insert the new post (start transaction)
			$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_ip, poster_email, message, smilies, posted, topic_id) VALUES(\''.addslashes($username).'\', \''.get_remote_address().'\', \''.$email.'\', \''.addslashes($message).'\', \''.$smilies.'\', '.$now.', '.$tid.')', PUN_TRANS_START) or error('Unable to create post', __FILE__, __LINE__, $db->error());
			$new_pid = $db->insert_id();
		}

		// Update topic
		$db->query('UPDATE '.$db->prefix.'topics SET num_replies=num_replies+1, last_post='.$now.', last_post_id='.$new_pid.', last_poster=\''.addslashes($username).'\' WHERE id='.$tid) or error('Unable to update topic', __FILE__, __LINE__, $db->error());

		update_search_index('post', $new_pid, $message);

		update_forum($forum_id, PUN_TRANS_END);	// end transaction


		// Get the post time for the previous post in this topic
		$result = $db->query('SELECT posted FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' ORDER BY id DESC LIMIT 1, 1') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
		$previous_post_time = $db->result($result, 0);

		// Get any subscribed users that should be notified (banned users are excluded)
		$result = $db->query('SELECT u.id, u.email, u.notify_with_post FROM '.$db->prefix.'users AS u INNER JOIN '.$db->prefix.'subscriptions AS s ON u.id=s.user_id LEFT JOIN '.$db->prefix.'bans AS b ON u.username=b.username WHERE b.username IS NULL AND s.topic_id='.$tid.' AND u.last_action>'.$previous_post_time.' AND u.id!='.intval($cur_user['id'])) or error('Unable to fetch subscription info', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
		{
			// Load the "new reply" template
			$fp = fopen($pun_root.'lang/'.$language.'/mail_templates/new_reply.tpl', 'r');
			$mail_tpl = trim(fread($fp, filesize($pun_root.'lang/'.$language.'/mail_templates/new_reply.tpl')));
			fclose($fp);

			// Load the "new reply full" template (with post included)
			$fp = fopen($pun_root.'lang/'.$language.'/mail_templates/new_reply_full.tpl', 'r');
			$mail_tpl_full = trim(fread($fp, filesize($pun_root.'lang/'.$language.'/mail_templates/new_reply_full.tpl')));
			fclose($fp);

			// The first row contains the subject
			$first_crlf = strpos($mail_tpl, "\n");
			$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
			$mail_message = trim(substr($mail_tpl, $first_crlf));

			$first_crlf = strpos($mail_tpl_full, "\n");
			$mail_subject_full = trim(substr($mail_tpl_full, 8, $first_crlf-8));
			$mail_message_full = trim(substr($mail_tpl_full, $first_crlf));

			$mail_subject = str_replace('<topic_subject>', '\''.$subject.'\'', $mail_subject);
			$mail_message = str_replace('<topic_subject>', '\''.$subject.'\'', $mail_message);
			$mail_message = str_replace('<replier>', $username, $mail_message);
			$mail_message = str_replace('<post_url>', $pun_config['o_base_url'].'/viewtopic.php?pid='.$new_pid.'#'.$new_pid, $mail_message);
			$mail_message = str_replace('<unsubscribe_url>', $pun_config['o_base_url'].'/misc.php?unsubscribe='.$tid, $mail_message);
			$mail_message = str_replace('<board_mailer>', $pun_config['o_board_title'].' '.$lang_common['Mailer'], $mail_message);

			$mail_subject_full = str_replace('<topic_subject>', '\''.$subject.'\'', $mail_subject_full);
			$mail_message_full = str_replace('<topic_subject>', '\''.$subject.'\'', $mail_message_full);
			$mail_message_full = str_replace('<replier>', $username, $mail_message_full);
			$mail_message_full = str_replace('<message>', $message, $mail_message_full);
			$mail_message_full = str_replace('<post_url>', $pun_config['o_base_url'].'/viewtopic.php?pid='.$new_pid.'#'.$new_pid, $mail_message_full);
			$mail_message_full = str_replace('<unsubscribe_url>', $pun_config['o_base_url'].'/misc.php?unsubscribe='.$tid, $mail_message_full);
			$mail_message_full = str_replace('<board_mailer>', $pun_config['o_board_title'].' '.$lang_common['Mailer'], $mail_message_full);

			require_once $pun_root.'include/email.php';

			// Loop through subscribed users and send e-mails
			while ($cur_subscriber = $db->fetch_assoc($result))
			{
				if ($cur_subscriber['notify_with_post'] == '0')
					pun_mail($cur_subscriber['email'], $mail_subject, $mail_message);
				else
					pun_mail($cur_subscriber['email'], $mail_subject_full, $mail_message_full);

				$notified_users[] = $cur_subscriber['id'];
			}
		}
	}
	// If it's a new topic
	else if (isset($_GET['fid']))
	{
		// Create the topic (start transaction)
		$db->query('INSERT INTO '.$db->prefix.'topics (poster, subject, posted, last_post, last_poster, forum_id) VALUES(\''.addslashes($username).'\', \''.addslashes($subject).'\', '.$now.', '.$now.', \''.addslashes($username).'\', '.$fid.')', PUN_TRANS_START) or error('Unable to create topic', __FILE__, __LINE__, $db->error());
		$new_tid = $db->insert_id();

		if (!$cookie['is_guest'])
		{
			// To subscribe or not to subscribe, that ...
			if ($pun_config['o_subscriptions'] == '1' && $_POST['subscribe'] == '1')
				$db->query('INSERT INTO '.$db->prefix.'subscriptions (user_id, topic_id) VALUES('.$cur_user['id'].' ,'.$new_tid.')') or error('Unable to add subscription', __FILE__, __LINE__, $db->error());

			// Create the post ("topic post")
			$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_id, poster_ip, message, smilies, posted, topic_id) VALUES(\''.addslashes($username).'\', '.$cur_user['id'].', \''.get_remote_address().'\', \''.addslashes($message).'\', \''.$smilies.'\', '.$now.', '.$new_tid.')') or error('Unable to create post', __FILE__, __LINE__, $db->error());
		}
		else
		{
			// Create the post ("topic post")
			$db->query('INSERT INTO '.$db->prefix.'posts (poster, poster_ip, poster_email, message, smilies, posted, topic_id) VALUES(\''.addslashes($username).'\', \''.get_remote_address().'\', \''.$email.'\', \''.addslashes($message).'\', \''.$smilies.'\', '.$now.', '.$new_tid.')') or error('Unable to create post', __FILE__, __LINE__, $db->error());
		}
		$new_pid = $db->insert_id();

		// Update the topic with last_post_id
		$db->query('UPDATE '.$db->prefix.'topics SET last_post_id='.$new_pid.' WHERE id='.$new_tid) or error('Unable to update topic', __FILE__, __LINE__, $db->error());

		update_search_index('post', $new_pid, $message, $subject);

		update_forum($fid, PUN_TRANS_END);	// end transaction
	}

	if (!$cookie['is_guest'])
		$db->query('UPDATE '.$db->prefix.'users SET num_posts=num_posts+1, last_post='.$now.' WHERE id='.$cur_user['id']) or error('Unable to update user', __FILE__, __LINE__, $db->error());

	redirect('viewtopic.php?pid='.$new_pid.'#'.$new_pid, $lang_post['Post redirect']);
}


else
{
	// If a topic id was specified in the url (it's a reply).
	if (isset($_GET['tid']))
	{
		$tid = intval($_GET['tid']);
		if (empty($tid))
			message($lang_common['Bad request']);

		if (($pun_config['p_guests_post'] == '0' && $cookie['is_guest']) || ($pun_config['p_users_post'] == '0' && $cur_user['status'] < PUN_MOD))
			message($lang_common['No permission']);

		$result = $db->query('SELECT subject, closed, forum_id FROM '.$db->prefix.'topics WHERE id='.$tid) or error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
		if (!$db->num_rows($result))
			message($lang_common['Bad request']);

		list($subject, $closed, $forum_id) = $db->fetch_row($result);

		$forum_closed = '0';
		if (!is_admmod($forum_id, $forum_closed, $admmod_only))
		{
			if (($admmod_only == '1' && $cur_user['status'] < PUN_MOD) || ($closed == '1' || $forum_closed == '1'))
				message($lang_common['No permission']);
		}

		$action = $lang_post['Post a reply'];
		$form = '<form method="post" action="post.php?action=post&amp;tid='.$tid.'" id="post" onsubmit="return process_form(this)">';

		// If a quote-id was specified in the url.
		if (isset($_GET['qid']))
		{
			$qid = intval($_GET['qid']);
			if (empty($qid))
				message($lang_common['Bad request']);

			$result = $db->query('SELECT poster, message FROM '.$db->prefix.'posts WHERE id='.$qid) or error('Unable to fetch quote info', __FILE__, __LINE__, $db->error());
			if (!$db->num_rows($result))
				message($lang_common['Bad request']);

			list($q_poster, $q_message) = $db->fetch_row($result);

			$q_message = str_replace('[img]', '[url]', $q_message);
			$q_message = str_replace('[/img]', '[/url]', $q_message);

			if ($pun_config['p_message_bbcode'] == '1')
			{
				// If username contains a square bracket, we add "" or '' around it (so we know when it starts and ends)
				if (strpos($q_poster, '[') !== false || strpos($q_poster, ']') !== false)
				{
					if (strpos($q_poster, '\'') !== false)
						$q_poster = '"'.$q_poster.'"';
					else
						$q_poster = '\''.$q_poster.'\'';
				}
				else
				{
					// Get the characters at the start and end of $q_poster
					$ends = substr($q_poster, 0, 1).substr($q_poster, -1, 1);

					// Deal with quoting "Username" or 'Username' (becomes '"Username"' or "'Username'")
					if ($ends == '\'\'')
						$q_poster = '"'.$q_poster.'"';
					else if ($ends == '""')
						$q_poster = '\''.$q_poster.'\'';
				}

				$quote = '[quote='.$q_poster.']'.$q_message.'[/quote]'."\n";
			}
			else
				$quote = '> '.$q_poster.' '.$lang_common['wrote'].':'."\n\n".'> '.$q_message."\n";
		}

		// We have to fetch the forum name in order to display Title / Forum / Topic
		$result = $db->query('SELECT forum_name FROM '.$db->prefix.'forums WHERE id='.$forum_id) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
		$forum = '<a href="viewforum.php?id='.$forum_id.'">'.pun_htmlspecialchars($db->result($result, 0)).'</a>';
	}
	// If a forum_id was specified in the url (new topic).
	else if (isset($_GET['fid']))
	{
		$fid = intval($_GET['fid']);
		if (empty($fid))
			message($lang_common['Bad request']);

		if (($pun_config['p_guests_post_topic'] == '0' && $cookie['is_guest']) || ($pun_config['p_users_post_topic'] == '0' && $cur_user['status'] < PUN_MOD))
			message($lang_common['No permission']);

		$result = $db->query('SELECT forum_name, moderators, admmod_only, closed FROM '.$db->prefix.'forums WHERE id='.$fid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
		if (!$db->num_rows($result))
			message($lang_common['Bad request']);

		list($forum_name, $moderators, $admmod_only, $forum_closed) = $db->fetch_row($result);
		$mods_array = ($moderators != '') ? unserialize($moderators) : array();

		if (($admmod_only == '1' && $cur_user['status'] < PUN_MOD) || ($forum_closed == '1' && $cur_user['status'] < PUN_ADMIN && !array_key_exists($cur_user['username'], $mods_array)))
			message($lang_common['No permission']);

		$action = $lang_post['Post new topic'];
		$form = '<form method="post" action="post.php?action=post&amp;fid='.$fid.'" id="post" onsubmit="return process_form(this)">';

		$forum = pun_htmlspecialchars($forum_name);
	}
	else
		message($lang_common['Bad request']);


	$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$action;
	$validate_form = true;
	$element_names = array('req_username' => $lang_common['Username'], 'req_email' => $lang_common['E-mail'], 'req_subject' => $lang_common['Subject'], 'req_message' => $lang_common['Message']);
	$form_name = 'post';

	if (!$cookie['is_guest'])
		$focus_element = (isset($_GET['fid'])) ? 'req_subject' : 'req_message';
	else
		$focus_element = 'req_username';

	require $pun_root.'header.php';

	$cur_index = 1;

?>
<table class="punspacer" cellspacing="1" cellpadding="4">
	<tr>
		<td><b><a href="index.php"><?php echo pun_htmlspecialchars($pun_config['o_board_title']) ?></a> / <?php echo $forum ?><?php if (isset($subject)) echo ' / '.pun_htmlspecialchars($subject) ?></b></td>
	</tr>
</table>

<?php echo $form."\n" ?>
	<input type="hidden" name="form_sent" value="1">
	<input type="hidden" name="form_user" value="<?php echo (!$cookie['is_guest']) ? pun_htmlspecialchars($cur_user['username']) : 'Guest'; ?>">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2"><?php echo $action ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['Username'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<?php echo (!$cookie['is_guest']) ? pun_htmlspecialchars($cur_user['username']) : '<input type="text" name="req_username" size="25" maxlength="25" tabindex="'.($cur_index++).'">'; ?></td>
		</tr>
<?php if ($cookie['is_guest']): ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['E-mail'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="req_email" size="50" maxlength="50" tabindex="<?php echo $cur_index++ ?>"></td>
		</tr>
<?php endif; ?><?php if (isset($fid)): ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['Subject'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="req_subject" size="80" maxlength="70" tabindex="<?php echo $cur_index++ ?>"></td>
		</tr>
<?php endif; ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap">
				<b><?php echo $lang_common['Message'] ?></b>&nbsp;&nbsp;<br><br>
				<a href="help.php#bbcode" target="_blank"><?php echo $lang_common['BBCode'] ?></a>: <?php echo ($pun_config['p_message_bbcode'] == '1') ? $lang_common['on'] : $lang_common['off']; ?>&nbsp;&nbsp;<br>
				<a href="help.php#img" target="_blank"><?php echo $lang_common['img tag'] ?></a>: <?php echo ($pun_config['p_message_img_tag'] == '1') ? $lang_common['on'] : $lang_common['off']; ?>&nbsp;&nbsp;<br>
				<a href="help.php#smilies" target="_blank"><?php echo $lang_common['Smilies'] ?></a>: <?php echo ($pun_config['o_smilies'] == '1') ? $lang_common['on'] : $lang_common['off']; ?>&nbsp;&nbsp;
			</td>
			<td class="puncon2">&nbsp;<textarea name="req_message" rows="20" cols="95" tabindex="<?php echo $cur_index++ ?>"><?php echo $quote ?></textarea></td>
		</tr>
<?php

	if (!$cookie['is_guest'])
	{
		if ($pun_config['o_smilies'] == '1')
		{
			if ($cur_user['smilies'] == '1')
				$checkboxes[] = '<input type="checkbox" name="smilies" value="1" tabindex="'.($cur_index++).'" checked>&nbsp;'.$lang_post['Show smilies'];
			else
				$checkboxes[] = '<input type="checkbox" name="smilies" value="1" tabindex="'.($cur_index++).'">&nbsp;'.$lang_post['Show smilies'];
		}

		if ($pun_config['o_subscriptions'] == '1')
			$checkboxes[] = '<input type="checkbox" name="subscribe" value="1" tabindex="'.($cur_index++).'">&nbsp;'.$lang_post['Subscribe'];

		if (isset($checkboxes))
			$checkboxes = implode('<br>'."\n\t\t\t\t", $checkboxes)."\n";
	}
	else if ($pun_config['o_smilies'] == '1')
		$checkboxes = '<input type="checkbox" name="smilies" value="1" tabindex="'.($cur_index++).'" checked>&nbsp;'.$lang_post['Show smilies']."\n";

	if (isset($checkboxes))
	{

?>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Options'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<?php echo $checkboxes ?>
			</td>
		</tr>
<?php

	}

?>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Actions'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2"><br>&nbsp;&nbsp;<input type="submit" name="submit" value="<?php echo $lang_common['Submit'] ?>" tabindex="<?php echo $cur_index++ ?>" accesskey="s">&nbsp;&nbsp;&nbsp;<a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a><br><br></td>
		</tr>
	</table>
</form>
<?php

	// Check to see if the topic review is to be displayed.
	if (isset($_GET['tid']) && $pun_config['o_topic_review'] > 0)
	{
		require $pun_root.'include/parser.php';

		$result = $db->query('SELECT poster, message, smilies, posted FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' ORDER BY id DESC LIMIT '.$pun_config['o_topic_review']) or error('Unable to fetch topic review', __FILE__, __LINE__, $db->error());

?>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead" colspan="2"><?php echo $lang_post['Topic review'] ?></td>
	</tr>
<?php

		while ($cur_post = $db->fetch_assoc($result))
		{
			$cur_post['message'] = parse_message($cur_post['message'], $cur_post['smilies']);

?>
	<tr>
		<td class="puncon1" style="width: 140px; vertical-align: top"><?php echo pun_htmlspecialchars($cur_post['poster']) ?></td>
		<td class="puncon2"><span class="puntext"><?php echo $cur_post['message'] ?></span></td>
	</tr>
<?php

		}
		echo "</table>\n";
	}

?>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

	require $pun_root.'footer.php';
}
