<?php
/***********************************************************************

  Copyright (C) 2002, 2003, 2004  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


$pun_root = './';
require $pun_root.'include/common.php';


if ($cookie['is_guest'] && $pun_config['p_guests_read'] == '0' && !isset($_GET['key']))
	message($lang_common['Login required']);


$action = $_GET['action'];
$id = intval($_GET['id']);
if ($id < 2)
	message($lang_common['Bad request']);

// Load the profile.php/register.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_prof_reg.php';

// Load the profile.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_profile.php';


if ($action == 'change_pass')
{
	if (isset($_GET['key']))
	{
		// If the user is already logged in we shouldn't be here :)
		if (!$cookie['is_guest'])
		{
			header('Location: index.php');
			exit;
		}

		$key = $_GET['key'];

		$result = $db->query('SELECT activate_string, activate_key FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch new password', __FILE__, __LINE__, $db->error());
		list($new_password_hash, $new_password_key) = $db->fetch_row($result);

		if ($key != $new_password_key)
			message($lang_profile['Pass key bad'].' <a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>.');
		else
		{
			$db->query('UPDATE '.$db->prefix.'users SET password=\''.$new_password_hash.'\', activate_string=NULL, activate_key=NULL WHERE id='.$id) or error('Unable to update password', __FILE__, __LINE__, $db->error());

			message($lang_profile['Pass updated'], true);
		}
	}

	// Make sure we are allowed to change this users password
	if ($cur_user['id'] != $id)
	{
		if ($cur_user['status'] < PUN_MOD)	// A regular user trying to change another users password?
			message($lang_common['No permission']);
		else if ($cur_user['status'] == PUN_MOD)	// A moderator trying to change an admin/mod's password?
		{
			$result = $db->query('SELECT status FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
			if (!$db->num_rows($result))
				message($lang_common['Bad request']);
			else if ($db->result($result) > PUN_USER)
				message($lang_common['No permission']);
		}
	}

	if (isset($_POST['form_sent']))
	{
		$old_password = unescape($_POST['req_old_password']);
		$new_password1 = unescape($_POST['req_new_password1']);
		$new_password2 = unescape($_POST['req_new_password2']);

		if ($new_password1 != $new_password2)
			message($lang_prof_reg['Pass not match']);
		if (strlen($new_password1) < 4)
			message($lang_prof_reg['Pass too short']);

		$result = $db->query('SELECT password, save_pass FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch password', __FILE__, __LINE__, $db->error());
		list($db_password_hash, $save_pass) = $db->fetch_row($result);

		$authorized = false;

		if (!empty($db_password_hash))
		{
			$sha1_in_db = (strlen($db_password_hash) == 40) ? true : false;
			$sha1_available = (function_exists('sha1') || function_exists('mhash')) ? true : false;

			$old_password_hash = pun_hash($old_password);	// This could result in either an SHA-1 or an MD5 hash

			if (($sha1_in_db && $sha1_available && $db_password_hash == $old_password_hash) ||
				(!$sha1_in_db && $db_password_hash == md5($old_password)) || 
				$cur_user['status'] > PUN_USER)
				$authorized = true;
		}

		if (!$authorized)
			message($lang_profile['Wrong pass']);

		$new_password_hash = pun_hash($new_password1);

		$db->query('UPDATE '.$db->prefix.'users SET password=\''.$new_password_hash.'\' WHERE id='.$id) or error('Unable to update password', __FILE__, __LINE__, $db->error());

		if ($cur_user['id'] == $id)
		{
			$expire = ($save_pass == '1') ? time() + 31536000 : 0;
			setcookie($cookie_name, serialize(array($cur_user['username'], $new_password_hash)), $expire, $cookie_path, $cookie_domain, $cookie_secure);
		}

		redirect('profile.php?id='.$id, $lang_profile['Pass updated redirect']);
	}
	else
	{
		$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_profile['Profile'];
		$validate_form = true;
		$element_names = array('req_old_password' => $lang_profile['Old pass'], 'req_new_password1' => $lang_profile['New pass'].' 1', 'req_new_password2' => $lang_profile['New pass'].' 2');
		$form_name = 'change_pass';
		$focus_element = ($cur_user['status'] < PUN_MOD) ? 'req_old_password' : 'req_new_password1';
		require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="profile.php?action=change_pass&amp;id=<?php echo $id ?>" id="change_pass" onsubmit="return process_form(this)">
	<input type="hidden" name="form_sent" value="1">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2"><?php echo $lang_profile['Change pass'] ?></td>
		</tr>
<?php if ($cur_user['status'] < PUN_MOD): ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_profile['Old pass'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="password" name="req_old_password" size="16" maxlength="16"></td>
		</tr>
<?php endif; ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_profile['New pass'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">
				&nbsp;<input type="password" name="req_new_password1" size="16" maxlength="16"><br>
				&nbsp;<input type="password" name="req_new_password2" size="16" maxlength="16">&nbsp;&nbsp;<?php echo $lang_prof_reg['Re-enter pass'] ?>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Actions'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2"><br>&nbsp;&nbsp;<input type="submit" name="update" value="<?php echo $lang_common['Submit'] ?>"><br><br></td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

		require $pun_root.'footer.php';
	}
}


else if ($action == 'change_email')
{
	if ($cookie['is_guest'] || ($cur_user['id'] != $id && $cur_user['status'] < PUN_MOD))
		message($lang_common['No permission']);

	if (isset($_GET['key']))
	{
		$key = $_GET['key'];

		$result = $db->query('SELECT activate_string, activate_key FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch activation data', __FILE__, __LINE__, $db->error());
		list($new_email, $new_email_key) = $db->fetch_row($result);

		if ($key != $new_email_key)
			message($lang_profile['E-mail key bad'].' <a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>.');
		else
		{
			$db->query('UPDATE '.$db->prefix.'users SET email=\''.$new_email.'\', activate_string=NULL, activate_key=NULL WHERE id='.$id) or error('Unable to update e-mail address', __FILE__, __LINE__, $db->error());

			message($lang_profile['E-mail updated'], true);
		}
	}
	else if (isset($_POST['form_sent']))
	{
		require $pun_root.'include/email.php';

		// Validate the email-address
		$new_email = strtolower(trim($_POST['req_new_email']));
		if (!is_valid_email($new_email))
			message($lang_common['Invalid e-mail']);

		// Check it it's a banned e-mail address
		if (is_banned_email($new_email))
		{
			if ($pun_config['p_allow_banned_email'] == '0')
				message($lang_prof_reg['Banned e-mail']);
			else if ($pun_config['o_mailing_list'] != '')
			{
				$mail_subject = 'Alert - Banned e-mail detected';
				$mail_message = 'User \''.$cur_user['username'].'\' changed to banned e-mail address: '.$new_email."\n\n".'User profile: '.$pun_config['o_base_url'].'/profile.php?id='.$id."\n\n".'-- '."\n".'Forum Mailer'."\n".'(Do not reply to this message)';

				require $pun_root.'include/email.php';

				pun_mail($pun_config['o_mailing_list'], $mail_subject, $mail_message);
			}
		}

		// Check if someone else already has registered with that e-mail address
		$result = $db->query('SELECT id, username FROM '.$db->prefix.'users WHERE email=\''.$new_email.'\'') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
		$num_dupes = $db->num_rows($result);

		if ($num_dupes)		// We found duplicate e-mail addresses
		{
			if ($pun_config['p_allow_dupe_email'] == '0')
				message($lang_prof_reg['Dupe e-mail']);
			else if ($pun_config['o_mailing_list'] != '')
			{
				while ($cur_dupe = $db->fetch_assoc($result))
					$dupe_list[] = $cur_dupe['username'];

				$mail_subject = 'Alert - Duplicate e-mail detected';
				$mail_message = 'User \''.$cur_user['username'].'\' changed to an e-mail address that also belongs to: '.implode(', ', $dupe_list)."\n\n".'User profile: '.$pun_config['o_base_url'].'/profile.php?id='.$id."\n\n".'-- '."\n".'Forum Mailer'."\n".'(Do not reply to this message)';

				require $pun_root.'include/email.php';

				pun_mail($pun_config['o_mailing_list'], $mail_subject, $mail_message);
			}
		}


		$new_email_key = random_pass(8);

		$db->query('UPDATE '.$db->prefix.'users SET activate_string=\''.$new_email.'\', activate_key=\''.$new_email_key.'\' WHERE id='.$id) or error('Unable to update activation data', __FILE__, __LINE__, $db->error());

		// Load the "activate e-mail" template
		$fp = fopen($pun_root.'lang/'.$language.'/mail_templates/activate_email.tpl', 'r');
		$mail_tpl = trim(fread($fp, filesize($pun_root.'lang/'.$language.'/mail_templates/activate_email.tpl')));
		fclose($fp);

		// The first row contains the subject
		$first_crlf = strpos($mail_tpl, "\n");
		$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
		$mail_message = trim(substr($mail_tpl, $first_crlf));

		$mail_message = str_replace('<username>', $cur_hit['username'], $mail_message);
		$mail_message = str_replace('<base_url>', $pun_config['o_base_url'], $mail_message);
		$mail_message = str_replace('<activation_url>', $pun_config['o_base_url'].'/profile.php?action=change_email&id='.$id.'&key='.$new_email_key, $mail_message);
		$mail_message = str_replace('<board_mailer>', $pun_config['o_board_title'].' '.$lang_common['Mailer'], $mail_message);

		pun_mail($new_email, $mail_subject, $mail_message);

		message($lang_profile['Activate e-mail sent'].' <a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>.', true);
	}
	else
	{
		$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_profile['Profile'];
		$validate_form = true;
		$element_names = array('req_new_email' => $lang_profile['New e-mail']);
		$form_name = 'change_email';
		$focus_element = 'req_new_email';
		require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead"><?php echo $lang_common['Info'] ?></td>
	</tr>
	<tr>
		<td class="puncon2"><?php echo $lang_profile['E-mail instructions'] ?></td>
	</tr>
</table>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="profile.php?action=change_email&amp;id=<?php echo $id ?>" id="change_email" onsubmit="return process_form(this)">
	<input type="hidden" name="form_sent" value="1">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2"><?php echo $lang_profile['Change e-mail'] ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_profile['New e-mail'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="req_new_email" size="50" maxlength="50"></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Actions'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2"><br>&nbsp;&nbsp;<input type="submit" name="new_email" value="<?php echo $lang_common['Submit'] ?>"><br><br></td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

		require $pun_root.'footer.php';
	}
}


else if ($action == 'upload_avatar' || $action == 'upload_avatar2')
{
	if ($pun_config['o_avatars'] == '0')
		message($lang_profile['Avatars disabled']);

	if ($cookie['is_guest'] || $cur_user['id'] != $id && $cur_user['status'] < PUN_MOD)
		message($lang_common['No permission']);

	if (isset($_POST['form_sent']))
	{
		$uploaded_file = $_FILES['req_file'];

		// Make sure the upload went smooth
		switch ($uploaded_file['error'])
		{
			case 1:	// UPLOAD_ERR_INI_SIZE
			case 2:	// UPLOAD_ERR_FORM_SIZE
				message($lang_profile['Too large ini']);
				break;

			case 3:	// UPLOAD_ERR_PARTIAL
				message($lang_profile['Partial upload']);
				break;

			case 4:	// UPLOAD_ERR_NO_FILE
				message($lang_profile['No file']);
				break;

			default:
				// No error occured, but was something actually uploaded?
				if ($uploaded_file['size'] == 0)
					message($lang_profile['No file']);
				break;
		}

		if (is_uploaded_file($uploaded_file['tmp_name']))
		{
			$allowed_types = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/png', 'image/x-png');

			if (!in_array($uploaded_file['type'], $allowed_types))
				message($lang_profile['Bad type']);

			list($width, $height, ,) = getimagesize($uploaded_file['tmp_name']);

			if ($width > $pun_config['o_avatars_width'])
				message($lang_profile['Too wide'].' '.$pun_config['o_avatars_width'].' '.$lang_profile['pixels'].'.');
			if ($height > $pun_config['o_avatars_height'])
				message($lang_profile['Too high'].' '.$pun_config['o_avatars_height'].' '.$lang_profile['pixels'].'.');
			if ($uploaded_file['size'] > $pun_config['o_avatars_size'])
				message($lang_profile['Too large'].' '.$pun_config['o_avatars_size'].' '.$lang_profile['bytes'].'.');

			if ($uploaded_file['type'] == 'image/gif')
			{
				$temp = @move_uploaded_file($uploaded_file['tmp_name'], $pun_config['o_avatars_dir'].'/'.$id.'.gif');
				@chmod($pun_config['o_avatars_dir'].'/'.$id.'.gif', 0644);
				@unlink($pun_config['o_avatars_dir'].'/'.$id.'.jpg');
				@unlink($pun_config['o_avatars_dir'].'/'.$id.'.png');
			}
			else if ($uploaded_file['type'] == 'image/jpeg' || $uploaded_file['type'] == 'image/pjpeg')
			{
				$temp = @move_uploaded_file($uploaded_file['tmp_name'], $pun_config['o_avatars_dir'].'/'.$id.'.jpg');
				@chmod($pun_config['o_avatars_dir'].'/'.$id.'.jpg', 0644);
				@unlink($pun_config['o_avatars_dir'].'/'.$id.'.gif');
				@unlink($pun_config['o_avatars_dir'].'/'.$id.'.png');
			}
			else if ($uploaded_file['type'] == 'image/png' || $uploaded_file['type'] == 'image/x-png')
			{
				$temp = @move_uploaded_file($uploaded_file['tmp_name'], $pun_config['o_avatars_dir'].'/'.$id.'.png');
				@chmod($pun_config['o_avatars_dir'].'/'.$id.'.png', 0644);
				@unlink($pun_config['o_avatars_dir'].'/'.$id.'.gif');
				@unlink($pun_config['o_avatars_dir'].'/'.$id.'.jpg');
			}

			if (!$temp)
				message($lang_profile['Move failed'].' <a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>.');
		}
		else
			message($lang_profile['Unknown failure']);

		// Enable use_avatar (seems sane since the user just uploaded an avatar)
		$db->query('UPDATE '.$db->prefix.'users SET use_avatar=1 WHERE id='.$id) or error('Unable to update avatar state', __FILE__, __LINE__, $db->error());

		redirect('profile.php?id='.$id, $lang_profile['Avatar upload redirect']);
	}
	else
	{
		$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_profile['Profile'];
		$validate_form = true;
		$element_names = array('req_file' => $lang_profile['File']);
		$form_name = 'upload_avatar';
		$focus_element = 'req_file';
		require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead"><?php echo $lang_common['Info'] ?></td>
	</tr>
	<tr>
		<td class="puncon2"><?php echo $lang_profile['Avatar desc'].' '.$pun_config['o_avatars_width'].' x '.$pun_config['o_avatars_height'].' '.$lang_profile['pixels'].' '.$lang_common['and'].' '.$pun_config['o_avatars_size'].' '.$lang_profile['bytes'].' ('.ceil($pun_config['o_avatars_size'] / 1024) ?> KB).</td>
	</tr>
</table>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" enctype="multipart/form-data" action="profile.php?action=upload_avatar2&amp;id=<?php echo $id ?>" id="upload_avatar" onsubmit="return process_form(this)">
	<input type="hidden" name="form_sent" value="1">
	<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $pun_config['o_avatars_size'] ?>">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2"><?php echo $lang_profile['Upload avatar'] ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_profile['File'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input name="req_file" type="file" size="40"></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Actions'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2"><br>&nbsp;&nbsp;<input type="submit" name="upload" value="<?php echo $lang_profile['Upload'] ?>"><br><br></td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

		require $pun_root.'footer.php';
	}
}


else if ($action == 'delete_avatar')
{
	if ($cur_user['status'] < PUN_ADMIN)
		message($lang_common['No permission']);

	confirm_referer('profile.php');

	@unlink($pun_config['o_avatars_dir'].'/'.$id.'.jpg');
	@unlink($pun_config['o_avatars_dir'].'/'.$id.'.png');
	@unlink($pun_config['o_avatars_dir'].'/'.$id.'.gif');

	redirect('profile.php?id='.$id, $lang_profile['Avatar deleted redirect']);
}


else if (isset($_POST['update_status']))
{
	if ($cur_user['status'] < PUN_ADMIN)
		message($lang_common['No permission']);

	confirm_referer('profile.php');

	$db->query('UPDATE '.$db->prefix.'users SET status='.$_POST['status'].' WHERE id='.$id) or error('Unable to update status', __FILE__, __LINE__, $db->error());

	redirect('profile.php?id='.$id, $lang_profile['Update status redirect']);
}


else if (isset($_POST['update_forums']))
{
	if ($cur_user['status'] < PUN_ADMIN)
		message($lang_common['No permission']);

	confirm_referer('profile.php');

	// Get the username of the user we are processing
	$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
	$username = $db->result($result, 0);

	$moderator_in = (isset($_POST['moderator_in'])) ? array_keys($_POST['moderator_in']) : array();

	// Loop through all forums
	$result = $db->query('SELECT id, moderators FROM '.$db->prefix.'forums') or error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());

	while ($cur_forum = $db->fetch_assoc($result))
	{
		$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

		// If the user should have moderator access (and he/she doesn't already have it)
		if (in_array($cur_forum['id'], $moderator_in) && !in_array($id, $cur_moderators))
		{
			$cur_moderators[$username] = $id;
			ksort($cur_moderators);

			$db->query('UPDATE '.$db->prefix.'forums SET moderators=\''.addslashes(serialize($cur_moderators)).'\' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
		}
		// If the user shouldn't have moderator access (and he/she already has it)
		else if (!in_array($cur_forum['id'], $moderator_in) && in_array($id, $cur_moderators))
		{
			unset($cur_moderators[$username]);
			$cur_moderators = (!empty($cur_moderators)) ? '\''.addslashes(serialize($cur_moderators)).'\'' : 'NULL';

			$db->query('UPDATE '.$db->prefix.'forums SET moderators='.$cur_moderators.' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
		}
	}

	redirect('profile.php?id='.$id, $lang_profile['Update forums redirect']);
}


else if (isset($_POST['ban']))
{
	if ($cur_user['status'] < PUN_MOD)
		message($lang_common['No permission']);

	redirect('admin_bans.php?add_ban='.$id, $lang_profile['Ban redirect']);
}


else if (isset($_POST['delete']) || isset($_POST['delete_comply']))
{
	if ($cur_user['status'] < PUN_ADMIN)
		message($lang_common['No permission']);

	confirm_referer('profile.php');

	// Get the username and status of the user we are deleting
	$result = $db->query('SELECT username, status FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
	list($username, $status) = $db->fetch_row($result);

	if (isset($_POST['delete_comply']))
	{
		// If the user is a moderator or an administrator, we remove him/her from the moderator list in all forums as well
		if ($status > PUN_USER)
		{
			$result = $db->query('SELECT id, moderators FROM '.$db->prefix.'forums') or error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());

			while ($cur_forum = $db->fetch_assoc($result))
			{
				$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

				if (in_array($id, $cur_moderators))
				{
					unset($cur_moderators[$username]);
					$cur_moderators = (!empty($cur_moderators)) ? '\''.addslashes(serialize($cur_moderators)).'\'' : 'NULL';

					$db->query('UPDATE '.$db->prefix.'forums SET moderators='.$cur_moderators.' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
				}
			}
		}

		// Delete any subscriptions
		$db->query('DELETE FROM '.$db->prefix.'subscriptions WHERE user_id='.$id) or error('Unable to delete subscriptions', __FILE__, __LINE__, $db->error());

		// Delete the user
		$db->query('DELETE FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to delete user', __FILE__, __LINE__, $db->error());

		// Set all his/her posts to guest
		$db->query('UPDATE '.$db->prefix.'posts SET poster_id=1 WHERE poster_id='.$id) or error('Unable to update posts', __FILE__, __LINE__, $db->error());

		redirect('index.php', $lang_profile['User delete redirect']);
	}
	else
	{
		$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_profile['Profile'];
		require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="profile.php?id=<?php echo $id ?>">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead"><?php echo $lang_profile['Confirm delete user'] ?></td>
		</tr>
		<tr>
			<td class="puncon2">
				<br>&nbsp;<?php echo $lang_profile['Are you sure'].' '.$username.'?' ?><br><br>
				&nbsp;<?php echo $lang_profile['Warning'] ?><br><br>
				&nbsp;<input type="submit" name="delete_comply" value="<?php echo $lang_profile['Delete'] ?>">&nbsp;&nbsp;&nbsp;<a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a><br><br>
			</td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

		require $pun_root.'footer.php';
	}
}


else if (isset($_POST['form_sent']))
{
	if ($cur_user['id'] != $id && $cur_user['status'] < PUN_MOD)
		message($lang_common['No permission']);

	// Extract elements from $_POST['form']
	$wanted_elements = array('realname', 'url', 'icq', 'msn', 'aim', 'yahoo', 'location', 'use_avatar', 'disp_topics', 'disp_posts', 'timezone', 'email_setting', 'save_pass', 'notify_with_post', 'smilies', 'show_img', 'show_avatars', 'show_sig', 'link_to_new_win', 'style');
	$form = array();

	while (list($key, $value) = @each($_POST['form']))
	{
	    if (in_array($key, $wanted_elements))
	        $form[$key] = $value;
	}


	if ($cur_user['status'] > PUN_USER)
	{
		confirm_referer('profile.php');

		$username = trim(unescape($_POST['username']));
		$old_username = trim(unescape($_POST['old_username']));

		if (strlen($username) < 2)
			message($lang_prof_reg['Username too short']);
		else if (pun_strlen($username) > 25)	// This usually doesn't happen since the form element only accepts 25 characters
		    message($lang_common['Bad request']);
		else if (!strcasecmp($username, 'Guest') || !strcasecmp($username, $lang_common['Guest']))
			message($lang_prof_reg['Username guest']);
		else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
			message($lang_prof_reg['Username IP']);
		else if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
			message($lang_prof_reg['Username BBCode']);

		// Check that the username is not already registered
		$result = $db->query('SELECT 1 FROM '.$db->prefix.'users WHERE username=\''.addslashes($username).'\' AND id!='.$id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
		if ($db->num_rows($result))
			message($lang_profile['Dupe username']);
	}


	// Clean up signature from POST
	$signature = pun_linebreaks(trim(unescape($_POST['signature'])));

	// Validate signature
	if (pun_strlen($signature) > $pun_config['p_sig_length'])
		message($lang_prof_reg['Sig too long'].' '.$pun_config['p_sig_length'].' '.$lang_prof_reg['characters'].'.');
	else if (substr_count($signature, "\n") > ($pun_config['p_sig_lines']-1))
		message($lang_prof_reg['Sig too many lines'].' '.$pun_config['p_sig_lines'].' '.$lang_prof_reg['lines'].'.');
	else if ($signature && $pun_config['p_sig_all_caps'] == '0' && strtoupper($signature) == $signature && $cur_user['status'] < PUN_MOD)
		message($lang_prof_reg['Sig caps']);

	if ($pun_config['p_sig_bbcode'] == '1')
	{
		// Change all BBCodes to lower case (this way a lot of regex searches can be case sensitive)
		$a = array('[B]', '[I]', '[U]', '[/B]', '[/I]', '[/U]');
		$b = array('[b]', '[i]', '[u]', '[/b]', '[/i]', '[/u]');
		$signature = str_replace($a, $b, $signature);

		$a = array('#\[colou?r=([a-zA-Z]*|\#?[0-9a-fA-F]{6})\]#i', '#\[/colou?r\]#i', '#\[img\]#i', '#\[/img\]#i', '#\[email\]#i', '#\[email=#i', '#\[/email\]#i', '#\[url\]#i', '#\[url=#i', '#\[/url\]#i');
		$b = array('[color=\\1]', '[/color]', '[img]', '[/img]', '[email]', '[email=', '[/email]', '[url]', '[url=', '[/url]');
		$signature = preg_replace($a, $b, $signature);

		if (preg_match('/\[quote\]|\[\/quote\]|\[code\]|\[\/code\]/i', $signature))
			message($lang_prof_reg['Signature quote/code']);
	}


	if ($pun_config['o_regs_verify'] == '0' || $cur_user['status'] > PUN_USER)
	{
		require $pun_root.'include/email.php';

		// Validate the email-address
		$email = strtolower(trim($_POST['req_email']));
		if (!is_valid_email($email))
			message($lang_common['Invalid e-mail']);
	}


	// Add http:// if the URL doesn't contain it already
	if ($form['url'] != '' && !stristr($form['url'], 'http://'))
		$form['url'] = 'http://'.$form['url'];

	// If the ICQ UIN contains anything other than digits it's invalid
	if ($form['icq'] != '' && preg_match('/[^0-9]/', $form['icq']))
		message($lang_prof_reg['Bad ICQ']);


	if ($form['disp_topics'] != '' && intval($form['disp_topics']) < 3) $form['disp_topics'] = 3;
	if ($form['disp_topics'] != '' && intval($form['disp_topics']) > 75) $form['disp_topics'] = 75;
	if ($form['disp_posts'] != '' && intval($form['disp_posts']) < 3) $form['disp_posts'] = 3;
	if ($form['disp_posts'] != '' && intval($form['disp_posts']) > 75) $form['disp_posts'] = 75;

	if ($form['use_avatar'] != '1') $form['use_avatar'] = '0';
	if ($form['save_pass'] != '1') $form['save_pass'] = '0';
	if ($form['notify_with_post'] != '1') $form['notify_with_post'] = '0';
	if ($form['smilies'] != '1') $form['smilies'] = '0';
	if ($form['show_img'] != '1') $form['show_img'] = '0';
	if ($form['show_avatars'] != '1') $form['show_avatars'] = '0';
	if ($form['show_sig'] != '1') $form['show_sig'] = '0';
	if ($form['link_to_new_win'] != '1') $form['link_to_new_win'] = '0';

	$form['email_setting'] == intval($form['email_setting']);
	if ($form['email_setting'] < 0 && $form['email_setting'] > 2) $form['email_setting'] = 1;

	// Singlequotes around non-empty values and NULL for empty values
	while (list($key, $input) = @each($form))
	{
		$value = ($input != '') ? '\''.escape($input).'\'' : 'NULL';

		$temp[] = $key.'='.$value;
	}


	if ($cur_user['status'] < PUN_MOD)
	{
		if ($pun_config['p_users_set_title'] == '1')
		{
			$user_title = trim($_POST['title']);

			if ($user_title != '')
			{
				// A list of words that the title may not contain
				// If $language == 'en', there will be some duplicates, but it's not the end of the world
				$forbidden = array('Member', 'Moderator', 'Administrator', 'Banned', 'Guest', $lang_common['Member'], $lang_common['Moderator'], $lang_common['Administrator'], $lang_common['Banned'], $lang_common['Guest']);

				if (in_array($user_title, $forbidden))
					message($lang_profile['Forbidden title']);
			}

			$user_title_sql = ($user_title != '') ? 'title=\''.escape($user_title).'\', ' : 'title=NULL, ';
		}

		$email_sql = ($pun_config['o_regs_verify'] == '0') ? 'email=\''.$email.'\', ' : '';

		$db->query('UPDATE '.$db->prefix.'users SET '.$email_sql.$user_title_sql.'signature=\''.addslashes($signature).'\', '.implode(',', $temp).' WHERE id='.$id) or error('Unable to update profile', __FILE__, __LINE__, $db->error());
	}
	else
	{
		$user_title = trim($_POST['title']);
		$admin_note = trim($_POST['admin_note']);

		$user_title = ($user_title != '') ? '\''.escape($user_title).'\'' : 'NULL';
		$admin_note = ($admin_note != '') ? '\''.escape($admin_note).'\'' : 'NULL';

		// We only allow administrators to update the post counter
		$posts_sql = ($cur_user['status'] == PUN_ADMIN) ? 'num_posts='.intval($_POST['num_posts']).', ' : '';

		$db->query('UPDATE '.$db->prefix.'users SET username=\''.addslashes($username).'\', email=\''.$email.'\', title='.$user_title.', signature=\''.addslashes($signature).'\', '.implode(',', $temp).', '.$posts_sql.'admin_note='.$admin_note.' WHERE id='.$id) or error('Unable to update profile', __FILE__, __LINE__, $db->error());

		// If we changed the username we have to update some stuff
		if ($username != $old_username)
		{
			$db->query('UPDATE '.$db->prefix.'posts SET poster=\''.addslashes($username).'\' WHERE poster_id='.$id) or error('Unable to update posts', __FILE__, __LINE__, $db->error());
			$db->query('UPDATE '.$db->prefix.'topics SET poster=\''.addslashes($username).'\' WHERE poster=\''.addslashes($old_username).'\'') or error('Unable to update topics', __FILE__, __LINE__, $db->error());
			$db->query('UPDATE '.$db->prefix.'topics SET last_poster=\''.addslashes($username).'\' WHERE last_poster=\''.addslashes($old_username).'\'') or error('Unable to update topics', __FILE__, __LINE__, $db->error());
			$db->query('UPDATE '.$db->prefix.'forums SET last_poster=\''.addslashes($username).'\' WHERE last_poster=\''.addslashes($old_username).'\'') or error('Unable to update forums', __FILE__, __LINE__, $db->error());
			$db->query('UPDATE '.$db->prefix.'online SET ident=\''.addslashes($username).'\' WHERE ident=\''.addslashes($old_username).'\'') or error('Unable to update online list', __FILE__, __LINE__, $db->error());

			// If the user is a moderator or an administrator we have to update the moderator lists
			$result = $db->query('SELECT status FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
			$status = $db->fetch_row($result);
	
			if ($status > PUN_USER)
			{
				$result = $db->query('SELECT id, moderators FROM '.$db->prefix.'forums') or error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());
	
				while ($cur_forum = $db->fetch_assoc($result))
				{
					$cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

					if (in_array($id, $cur_moderators))
					{
						unset($cur_moderators[$old_username]);
						$cur_moderators[$username] = $id;
						ksort($cur_moderators);

						$db->query('UPDATE '.$db->prefix.'forums SET moderators=\''.addslashes(serialize($cur_moderators)).'\' WHERE id='.$cur_forum['id']) or error('Unable to update forum', __FILE__, __LINE__, $db->error());
					}
				}
			}
		}
	}

	redirect('profile.php?id='.$id, $lang_profile['Profile redirect']);
}


else
{
	$result = $db->query('SELECT username, email, title, realname, url, icq, msn, aim, yahoo, location, use_avatar, signature, disp_topics, disp_posts, email_setting, save_pass, notify_with_post, smilies, show_img, show_avatars, show_sig, link_to_new_win, timezone, style, num_posts, status, last_post, registered, admin_note FROM '.$db->prefix.'users WHERE id='.$id) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
	if (!$db->num_rows($result))
		message($lang_common['Bad request']);

	$user = $db->fetch_assoc($result);

	$last_post = format_time($user['last_post']);

	if ($user['signature'] != '')
	{
		require $pun_root.'include/parser.php';

		$parsed_signature = parse_signature($user['signature']);
	}

	// Are we viewing someone else's profile? (and are we not an admin/moderator)
	if ($cur_user['id'] != $id && $cur_user['status'] < PUN_MOD)
	{
		if ($user['email_setting'] == '0')
			$email_field = '<a href="mailto:'.$user['email'].'">'.$user['email'].'</a>';
		else if ($user['email_setting'] == '1' && !$cookie['is_guest'])
			$email_field = '<a href="misc.php?email='.$id.'">'.$lang_common['Send e-mail'].'</a>';
		else
			$email_field = $lang_profile['Private'];

		$user_title_field = get_title($user);

		if ($user['url'] != '')
		{
			$user['url'] = pun_htmlspecialchars($user['url']);

			if ($pun_config['o_censoring'] == '1')
				$user['url'] = censor_words($user['url']);

			if ($cur_user['link_to_new_win'] != '0')
				$url = '<a href="'.$user['url'].'" target="_blank">'.$user['url'].'</a>';
			else
				$url = '<a href="'.$user['url'].'">'.$user['url'].'</a>';
		}

		if ($pun_config['o_avatars'] == '1')
		{
			if ($user['use_avatar'] == '1')
			{
				if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.gif'))
					$avatar_field = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$id.'.gif" '.$img_size[3].' alt="">';
				else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.jpg'))
					$avatar_field = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$id.'.jpg" '.$img_size[3].' alt="">';
				else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.png'))
					$avatar_field = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$id.'.png" '.$img_size[3].' alt="">';
			}
			else
				$avatar_field = $lang_profile['No avatar'];
		}

		if ($pun_config['o_show_post_count'] == '1' || $cur_user['status'] > PUN_USER)
			$posts_field = $user['num_posts'].' - <a href="search.php?action=show_user&amp;user_id='.$id.'">'.$lang_profile['Show posts'].'</a>';
		else
			$posts_field .= '<a href="search.php?action=show_user&amp;user_id='.$id.'">'.$lang_profile['Show posts'].'</a>';


		$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_profile['Profile'];
		require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead" colspan="2"><?php echo $lang_profile['Profile'] ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Username'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo pun_htmlspecialchars($user['username']) ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['E-mail'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo $email_field ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Title'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo ($pun_config['o_censoring'] == '1') ? censor_words($user_title_field) : $user_title_field; ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Realname'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo pun_htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['realname']) : $user['realname']) ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Website'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo $url ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['ICQ'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo $user['icq'] ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['MSN'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo pun_htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['msn']) : $user['msn']) ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['AOL IM'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo pun_htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['aim']) : $user['aim']) ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Yahoo'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo pun_htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['yahoo']) : $user['yahoo']) ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Location'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo pun_htmlspecialchars(($pun_config['o_censoring'] == '1') ? censor_words($user['location']) : $user['location']) ?></td>
	</tr>
<?php if ($pun_config['o_avatars'] == '1'): ?>	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Avatar'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo $avatar_field ?></td>
	</tr>
<?php endif; ?>	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Signature'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">
			<table class="punplain" style="width: 80%" cellspacing="0" cellpadding="4">
				<tr>
					<td>
						<?php echo ($parsed_signature != '') ? $parsed_signature."\n" : $lang_profile['No sig']."\n"; ?>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Posts'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo $posts_field ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Last post'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo $last_post ?></td>
	</tr>
	<tr>
		<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Registered'] ?>&nbsp;&nbsp;</td>
		<td class="puncon2">&nbsp;<?php echo format_time($user['registered'], true) ?></td>
	</tr>
</table>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

	}
	else
	{
		$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_profile['Profile'];
		$validate_form = true;
		$element_names = array('req_email' => $lang_common['E-mail']);
		require $pun_root.'header.php';

		if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.gif'))
			$avatar_field = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$id.'.gif" '.$img_size[3].' alt=""><br>&nbsp;<a href="profile.php?action=upload_avatar&amp;id='.$id.'">'.$lang_profile['Change avatar'].'</a>';
		else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.jpg'))
			$avatar_field = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$id.'.jpg" '.$img_size[3].' alt=""><br>&nbsp;<a href="profile.php?action=upload_avatar&amp;id='.$id.'">'.$lang_profile['Change avatar'].'</a>';
		else if ($img_size = @getimagesize($pun_config['o_avatars_dir'].'/'.$id.'.png'))
			$avatar_field = '<img class="punavatar" src="'.$pun_config['o_avatars_dir'].'/'.$id.'.png" '.$img_size[3].' alt=""><br>&nbsp;<a href="profile.php?action=upload_avatar&amp;id='.$id.'">'.$lang_profile['Change avatar'].'</a>';
		else
			$avatar_field = '<a href="profile.php?action=upload_avatar&amp;id='.$id.'">'.$lang_profile['Upload avatar'].'</a>';

		if ($cur_user['status'] > PUN_USER)
		{
			$username_field = '<input type="hidden" name="old_username" value="'.pun_htmlspecialchars($user['username']).'"><input type="text" name="username" value="'.pun_htmlspecialchars($user['username']).'" size="25" maxlength="25">';
			$email_field = '<input type="text" name="req_email" value="'.$user['email'].'" size="40" maxlength="50"> - <a href="misc.php?email='.$id.'">'.$lang_common['Send e-mail'].'</a>';
			$user_title_field = '<input type="text" name="title" value="'.$user['title'].'" size="30" maxlength="50">&nbsp;&nbsp;'.$lang_profile['Leave blank'];

			if ($cur_user['status'] == PUN_ADMIN && $img_size)
				$avatar_field .= '<br>&nbsp;<a href="profile.php?action=delete_avatar&amp;id='.$id.'">'.$lang_profile['Delete avatar'].'</a>';
		}
		else
		{
			$username_field = pun_htmlspecialchars($user['username']);

			if ($pun_config['o_regs_verify'] == '1')
				$email_field = $user['email'].'&nbsp;-&nbsp;<a href="profile.php?action=change_email&amp;id='.$id.'">'.$lang_profile['Change e-mail'].'</a>';
			else
				$email_field = '<input type="text" name="req_email" value="'.$user['email'].'" size="40" maxlength="50">';

			if ($pun_config['p_users_set_title'] == '1')
				$user_title_field = '<input type="text" name="title" value="'.$user['title'].'" size="30" maxlength="50">&nbsp;&nbsp;'.$lang_profile['Leave blank'];
			else
			{
				$user_title_field = get_title($user);

				if ($pun_config['o_censoring'] == '1')
					$user_title_field = censor_words($user_title_field);
			}
		}

		if ($user['signature'] != '')
			$preview = '&nbsp;'.$lang_profile['Sig preview'].'<br>'."\n\t\t\t\t".'&nbsp;_______________________________________<br>'."\n\t\t\t\t".'<table class="punplain" style="width: 80%" cellspacing="0" cellpadding="4">'."\n\t\t\t\t\t".'<tr>'."\n\t\t\t\t\t\t".'<td>'.$parsed_signature.'</td>'."\n\t\t\t\t\t".'</tr>'."\n\t\t\t\t".'</table><br>'."\n";
		else
			$preview = '&nbsp;'.$lang_profile['Sig preview'].'<br>'."\n\t\t\t\t".'&nbsp;_______________________________________<br>'."\n\t\t\t\t".'&nbsp;'.$lang_profile['No sig'].'<br><br>'."\n";

		$posts_field = '<a href="search.php?action=show_user&amp;user_id='.$id.'">'.$lang_profile['Show posts'].'</a>';
		if ($cur_user['status'] == PUN_ADMIN)
			$posts_field = '<input type="text" name="num_posts" value="'.$user['num_posts'].'" size="8" maxlength="8"> - '.$posts_field;
		else if ($pun_config['o_show_post_count'] == '1' || $cur_user['status'] > PUN_USER)
			$posts_field = $user['num_posts'].' - '.$posts_field;


?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="profile.php?id=<?php echo $id ?>" onsubmit="return process_form(this)">
	<input type="hidden" name="form_sent" value="1">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2"><?php echo $lang_profile['Profile'] ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['Username'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<?php echo $username_field ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['Password'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<a href="profile.php?action=change_pass&amp;id=<?php echo $id ?>"><?php echo $lang_profile['Change pass'] ?></a></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['E-mail'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<?php echo $email_field ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Title'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<?php echo $user_title_field ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Realname'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[realname]" value="<?php echo pun_htmlspecialchars($user['realname']) ?>" size="40" maxlength="40"></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Website'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[url]" value="<?php echo pun_htmlspecialchars($user['url']) ?>" size="50" maxlength="80"></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['ICQ'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[icq]" value="<?php echo $user['icq'] ?>" size="12" maxlength="12"></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['MSN'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[msn]" value="<?php echo pun_htmlspecialchars($user['msn']) ?>" size="40" maxlength="50"></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['AOL IM'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[aim]" value="<?php echo pun_htmlspecialchars($user['aim']) ?>" size="20" maxlength="20"></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Yahoo'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[yahoo]" value="<?php echo pun_htmlspecialchars($user['yahoo']) ?>" size="20" maxlength="20"></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Location'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[location]" value="<?php echo pun_htmlspecialchars($user['location']) ?>" size="30" maxlength="30"></td>
		</tr>
<?php if ($pun_config['o_avatars'] == '1'): ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Avatar'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_profile['Avatar info'] ?></div><br>
				&nbsp;<?php echo $avatar_field ?><br><br>
				<input type="checkbox" name="form[use_avatar]" value="1"<?php if ($user['use_avatar'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_profile['Use avatar'] ?>
			</td>
		</tr>
<?php endif; ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap">
				<?php echo $lang_profile['Signature'] ?>&nbsp;&nbsp;<br><br>
				<a href="help.php#bbcode" target="_blank"><?php echo $lang_common['BBCode'] ?></a>: <?php echo ($pun_config['p_sig_bbcode'] == '1') ? $lang_common['on'] : $lang_common['off']; ?>&nbsp;&nbsp;<br>
				<a href="help.php#img" target="_blank"><?php echo $lang_common['img tag'] ?></a>: <?php echo ($pun_config['p_sig_img_tag'] == '1') ? $lang_common['on'] : $lang_common['off']; ?>&nbsp;&nbsp;<br>
				<a href="help.php#smilies" target="_blank"><?php echo $lang_common['Smilies'] ?></a>: <?php echo ($pun_config['o_smilies_sig'] == '1') ? $lang_common['on'] : $lang_common['off']; ?>&nbsp;&nbsp;<br>
				<?php echo $lang_profile['Sig max length'] ?>: <?php echo $pun_config['p_sig_length'] ?>&nbsp;&nbsp;<br>
				<?php echo $lang_profile['Sig max lines'] ?>: <?php echo $pun_config['p_sig_lines'] ?>&nbsp;&nbsp;
			</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_profile['Signature info'] ?></div><br>
				&nbsp;<textarea name="signature" rows="7" cols="65"><?php echo pun_htmlspecialchars($user['signature']) ?></textarea><br><br>
				<?php echo $preview ?>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Topics per page'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[disp_topics]" value="<?php echo $user['disp_topics'] ?>" size="3" maxlength="3">&nbsp;&nbsp;<?php echo $lang_profile['Leave blank'] ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Posts per page'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="form[disp_posts]" value="<?php echo $user['disp_posts'] ?>" size="3" maxlength="3">&nbsp;&nbsp;<?php echo $lang_profile['Leave blank'] ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_prof_reg['Timezone'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_prof_reg['Timezone info'] ?></div><br>
				&nbsp;<select name="form[timezone]">
					<option value="-12"<?php if ($user['timezone'] == -12) echo ' selected' ?>>-12</option>
					<option value="-11"<?php if ($user['timezone'] == -11) echo ' selected' ?>>-11</option>
					<option value="-10"<?php if ($user['timezone'] == -10) echo ' selected' ?>>-10</option>
					<option value="-9"<?php if ($user['timezone'] == -9) echo ' selected' ?>>-09</option>
					<option value="-8"<?php if ($user['timezone'] == -8) echo ' selected' ?>>-08 PST</option>
					<option value="-7"<?php if ($user['timezone'] == -7) echo ' selected' ?>>-07 MST</option>
					<option value="-6"<?php if ($user['timezone'] == -6) echo ' selected' ?>>-06 CST</option>
					<option value="-5"<?php if ($user['timezone'] == -5) echo ' selected' ?>>-05 EST</option>
					<option value="-4"<?php if ($user['timezone'] == -4) echo ' selected' ?>>-04 AST</option>
					<option value="-3"<?php if ($user['timezone'] == -3) echo ' selected' ?>>-03 ADT</option>
					<option value="-2"<?php if ($user['timezone'] == -2) echo ' selected' ?>>-02</option>
					<option value="-1"<?php if ($user['timezone'] == -1) echo ' selected' ?>>-01</option>
					<option value="0"<?php if ($user['timezone'] == 0) echo ' selected' ?>>00 GMT</option>
					<option value="1"<?php if ($user['timezone'] == 1) echo ' selected' ?>>+01 CET</option>
					<option value="2"<?php if ($user['timezone'] == 2) echo ' selected' ?>>+02</option>
					<option value="3"<?php if ($user['timezone'] == 3) echo ' selected' ?>>+03</option>
					<option value="4"<?php if ($user['timezone'] == 4) echo ' selected' ?>>+04</option>
					<option value="5"<?php if ($user['timezone'] == 5) echo ' selected' ?>>+05</option>
					<option value="6"<?php if ($user['timezone'] == 6) echo ' selected' ?>>+06</option>
					<option value="7"<?php if ($user['timezone'] == 7) echo ' selected' ?>>+07</option>
					<option value="8"<?php if ($user['timezone'] == 8) echo ' selected' ?>>+08</option>
					<option value="9"<?php if ($user['timezone'] == 9) echo ' selected' ?>>+09</option>
					<option value="10"<?php if ($user['timezone'] == 10) echo ' selected' ?>>+10</option>
					<option value="11"<?php if ($user['timezone'] == 11) echo ' selected' ?>>+11</option>
					<option value="12"<?php if ($user['timezone'] == 12) echo ' selected' ?>>+12</option>
					<option value="13"<?php if ($user['timezone'] == 13) echo ' selected' ?>>+13</option>
				</select>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Options'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_prof_reg['E-mail setting info'] ?></div>
				<input type="radio" name="form[email_setting]" value="0"<?php if ($user['email_setting'] == '0') echo ' checked' ?>>&nbsp;<?php echo $lang_prof_reg['E-mail setting 1'] ?><br>
				<input type="radio" name="form[email_setting]" value="1"<?php if ($user['email_setting'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_prof_reg['E-mail setting 2'] ?><br>
				<input type="radio" name="form[email_setting]" value="2"<?php if ($user['email_setting'] == '2') echo ' checked' ?>>&nbsp;<?php echo $lang_prof_reg['E-mail setting 3'] ?><br><br>
				<div style="padding-left: 4px"><?php echo $lang_prof_reg['Save user/pass info'] ?></div>
				<input type="checkbox" name="form[save_pass]" value="1"<?php if ($user['save_pass'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_prof_reg['Save user/pass'] ?><br><br>
				<div style="padding-left: 4px"><?php echo $lang_profile['Notify full info'] ?></div>
				<input type="checkbox" name="form[notify_with_post]" value="1"<?php if ($user['notify_with_post'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_profile['Notify full'] ?><br><br>
				<div style="padding-left: 4px"><?php echo $lang_profile['Use smilies info'] ?></div>
				<input type="checkbox" name="form[smilies]" value="1"<?php if ($user['smilies'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_profile['Use smilies'] ?><br><br>
				<div style="padding-left: 4px"><?php echo $lang_profile['Show images info'] ?></div>
				<input type="checkbox" name="form[show_img]" value="1"<?php if ($user['show_img'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_profile['Show images'] ?><br><br>
				<div style="padding-left: 4px"><?php echo $lang_profile['Show avatars info'] ?></div>
				<input type="checkbox" name="form[show_avatars]" value="1"<?php if ($user['show_avatars'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_profile['Show avatars'] ?><br><br>
				<div style="padding-left: 4px"><?php echo $lang_profile['Show sigs info'] ?></div>
				<input type="checkbox" name="form[show_sig]" value="1"<?php if ($user['show_sig'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_profile['Show sigs'] ?><br><br>
				<div style="padding-left: 4px"><?php echo $lang_profile['Open links new win info'] ?></div>
				<input type="checkbox" name="form[link_to_new_win]" value="1"<?php if ($user['link_to_new_win'] == '1') echo ' checked' ?>>&nbsp;<?php echo $lang_profile['Open links new win'] ?>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Style'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_profile['Style info'] ?></div><br>
				&nbsp;<select name="form[style]">
<?php

		$d = dir($pun_root.'style');
		while (($entry = $d->read()) !== false)
		{
			if (substr($entry, strlen($entry)-4) == '.css')
				$styles[] = substr($entry, 0, strlen($entry)-4);
		}
		$d->close();

		while (list(, $temp) = @each($styles))
		{
			if ($user['style'] == $temp)
				echo "\t\t\t\t\t".'<option value="'.$temp.'" selected>'.str_replace('_', ' ', $temp).'</option>'."\n";
			else
				echo "\t\t\t\t\t".'<option value="'.$temp.'">'.str_replace('_', ' ', $temp).'</option>'."\n";
		}

?>
				</select>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Registered'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<?php echo format_time($user['registered'], true) ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Last post'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<?php echo $last_post ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Posts'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<?php echo $posts_field ?></td>
		</tr>
<?php if ($cur_user['status'] > PUN_USER): ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Admin note'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">&nbsp;<input type="text" name="admin_note" value="<?php echo pun_htmlspecialchars($user['admin_note']) ?>" size="30" maxlength="30"></td>
		</tr>
<?php endif; ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Actions'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2" style="white-space: nowrap">
				<br>&nbsp;&nbsp;<input type="submit" name="update" value="<?php echo $lang_common['Submit'] ?>"><br><br>
				&nbsp;<?php echo $lang_profile['Instructions'] ?><br><br>
			</td>
		</tr>
	</table>
</form>
<?php

	// Should we show user administration?
	if ($cur_user['status'] > PUN_USER)
	{

?>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="profile.php?id=<?php echo $id ?>&action=foo">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2"><?php echo $lang_profile['User admin'] ?></td>
		</tr>
<?php

		if ($cur_user['status'] == PUN_MOD)
		{

?>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Actions'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2" style="white-space: nowrap">
				<br>&nbsp;&nbsp;<input type="submit" name="ban" value="<?php echo $lang_profile['Ban user'] ?>"><br><br>
			</td>
		</tr>
<?php

		}
		else
		{

?>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Choose status'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_profile['Choose status info'] ?></div><br>
				&nbsp;&nbsp;<select name="status">
					<option value="<?php echo PUN_USER ?>"<?php if ($user['status'] < PUN_MOD) echo ' selected'?>><?php echo $lang_common['Member'] ?></option>
					<option value="<?php echo PUN_MOD ?>"<?php if ($user['status'] == PUN_MOD) echo ' selected'?>><?php echo $lang_common['Moderator'] ?></option>
					<option value="<?php echo PUN_ADMIN ?>"<?php if ($user['status'] == PUN_ADMIN ) echo ' selected'?>><?php echo $lang_common['Administrator'] ?></option>
				</select>
				&nbsp;&nbsp;<input type="submit" name="update_status" value="<?php echo $lang_profile['Update status'] ?>"><br><br>
			</td>
		</tr>
<?php if ($user['status'] > PUN_USER): ?>		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_profile['Moderator in'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_profile['Moderator in info'] ?><br><br>
<?php

			$result = $db->query('SELECT c.id AS cid, c.cat_name, f.id AS fid, f.forum_name, f.moderators FROM '.$db->prefix.'categories AS c INNER JOIN '.$db->prefix.'forums AS f ON c.id=f.cat_id'.$extra.' ORDER BY c.disp_position, c.id, f.disp_position') or error('Unable to fetch category/forum list', __FILE__, __LINE__, $db->error());

			while ($cur_forum = $db->fetch_assoc($result))
			{
				if ($cur_forum['cid'] != $cur_category)	// A new category since last iteration?
				{
					echo "\t\t\t\t".$cur_forum['cat_name'].'<br>';
					$cur_category = $cur_forum['cid'];
				}
				
				$moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();

				echo "\t\t\t\t".'<input type="checkbox" name="moderator_in['.$cur_forum['fid'].']" value="1"'.((in_array($id, $moderators)) ? ' checked' : '').'>&nbsp;'.pun_htmlspecialchars($cur_forum['forum_name']).'<br>'."\n";
			}

?>
				</div>
				<br>&nbsp;&nbsp;<input type="submit" name="update_forums" value="<?php echo $lang_profile['Update forums'] ?>"><br><br>
			</td>
<?php endif; ?>		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Actions'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2" style="white-space: nowrap">
				<br>&nbsp;&nbsp;<input type="submit" name="delete" value="<?php echo $lang_profile['Delete user'] ?>">&nbsp;&nbsp;<input type="submit" name="ban" value="<?php echo $lang_profile['Ban user'] ?>"><br><br>
			</td>
		</tr>

<?php

		}

?>
			</td>
		</tr>
	</table>
</form>
<?php

	}

?>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

	}

	require $pun_root.'footer.php';
}
