<?php
/***********************************************************************

  Copyright (C) 2002, 2003, 2004  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


$pun_root = './';
require $pun_root.'include/common.php';


// If we are logged in, we shouldn't be here
if (!$cookie['is_guest'])
{
	header('Location: index.php');
	exit;
}

// Load the register.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_register.php';

// Load the register.php/profile.php language file
require $pun_root.'lang/'.$language.'/'.$language.'_prof_reg.php';

if ($pun_config['o_regs_allow'] == '0')
	message($lang_register['No new regs']);


// User pressed the cancel button
if (isset($_POST['cancel']))
	redirect('index.php', $lang_register['Reg cancel redirect']);


else if ($pun_config['o_rules'] == '1' && !isset($_POST['accept']) && !isset($_POST['form_sent']))
{
	$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_register['Register'];
	require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="register.php">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead"><?php echo $lang_register['Forum rules'] ?></td>
		</tr>
		<tr>
			<td class="puncon2">
				<?php echo $pun_config['o_rules_message'] ?>
				<br><br><br><div style="text-align: center"><input type="submit" name="accept" value="<?php echo $lang_register['Accept'] ?>">&nbsp;&nbsp;<input type="submit" name="cancel" value="<?php echo $lang_register['Cancel'] ?>"></div><br>
			</td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

	require $pun_root.'footer.php';
}


else if (isset($_POST['form_sent']))
{
	$username = trim(unescape($_POST['req_username']));
	$email1 = strtolower(trim($_POST['req_email1']));

	if ($pun_config['o_regs_verify'] == '1')
	{
		$email2 = strtolower(trim($_POST['req_email2']));

		$password1 = random_pass(8);
		$password2 = $password1;
	}
	else
	{
		$password1 = trim(unescape($_POST['req_password1']));
		$password2 = trim(unescape($_POST['req_password2']));
	}

	// Convert multiple whitespace characters into one (to prevent people from registering with indistinguishable usernames)
	$username = preg_replace('#\s+#s', ' ', $username);

	// Validate username and passwords
	if (strlen($username) < 2)
		message($lang_prof_reg['Username too short']);
	else if (pun_strlen($username) > 25)	// This usually doesn't happen since the form element only accepts 25 characters
	    message($lang_common['Bad request']);
	else if (strlen($password1) < 4)
		message($lang_prof_reg['Pass too short']);
	else if ($password1 != $password2)
		message($lang_prof_reg['Pass not match']);
	else if (!strcasecmp($username, 'Guest') || !strcasecmp($username, $lang_common['Guest']))
		message($lang_prof_reg['Username guest']);
	else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
		message($lang_prof_reg['Username IP']);
	else if ((strpos($username, '[') !== false || strpos($username, ']') !== false) && strpos($username, '\'') !== false && strpos($username, '"') !== false)
		message($lang_prof_reg['Username reserved chars']);
	else if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
		message($lang_prof_reg['Username BBCode']);

	// Check username for any censored words
	if ($pun_config['o_censoring'] == '1')
	{
		// If the censored username differs from the username
		if (censor_words($username) != $username)
			message($lang_register['Username censor']);
	}

	// Check that the username (or a too similar username) is not already registered
	$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE username=\''.addslashes($username).'\' OR username=\''.addslashes(preg_replace('/[^\w]/', '', $username)).'\'') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());

	if ($db->num_rows($result))
	{
		$busy = $db->result($result, 0);
		message($lang_register['Username dupe 1'].' '.pun_htmlspecialchars($busy).'. '.$lang_register['Username dupe 2']);
	}


	// Validate e-mail
	require $pun_root.'include/email.php';

	if (!is_valid_email($email1))
		message($lang_common['Invalid e-mail']);
	else if ($pun_config['o_regs_verify'] == '1' && $email1 != $email2)
		message($lang_register['E-mail not match']);

	// Check it it's a banned e-mail address
	if (is_banned_email($email1))
	{
		if ($pun_config['p_allow_banned_email'] == '0')
			message($lang_prof_reg['Banned e-mail']);

		$banned_email = true;	// Used later when we send an alert e-mail
	}

	// Check if someone else already has registered with that e-mail address
	$result = $db->query('SELECT id, username FROM '.$db->prefix.'users WHERE email=\''.$email1.'\'') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
	$num_dupes = $db->num_rows($result);

	if ($num_dupes > 0 && $pun_config['p_allow_dupe_email'] == '0')
		message($lang_prof_reg['Dupe e-mail']);

	$timezone = intval($_POST['timezone']);
	$save_pass = ($_POST['save_pass'] != '1') ? '0' : '1';

	$email_setting = intval($_POST['email_setting']);
	if ($email_setting < 0 && $email_setting > 2) $email_setting = 1;

	// Insert the new user into the database. We do this now to get the last inserted id for later use.
	$now = time();

	$intial_status = ($pun_config['o_regs_verify'] == '0') ? PUN_USER : PUN_INACTIVE;
	$password_hash = pun_hash($password1);

	// Add the user
	$db->query('INSERT INTO '.$db->prefix.'users (username, password, email, email_setting, save_pass, timezone, style, status, registered, last_visit, last_action) VALUES(\''.addslashes($username).'\', \''.$password_hash.'\', \''.$email1.'\', '.$email_setting.', '.$save_pass.', '.$timezone.' ,\''.$pun_config['o_default_style'].'\' ,'.$intial_status.', '.$now.', '.$now.', '.$now.')') or error('Unable to create user', __FILE__, __LINE__, $db->error());
	$new_uid = $db->insert_id();


	// If we previously found out that the e-mail was banned
	if ($banned_email && $pun_config['o_mailing_list'] != '')
	{
		$mail_subject = 'Alert - Banned e-mail detected';
		$mail_message = 'User \''.$username.'\' registered with banned e-mail address: '.$email1."\n\n".'User profile: '.$pun_config['o_base_url'].'/profile.php?id='.$new_uid."\n\n".'-- '."\n".'Forum Mailer'."\n".'(Do not reply to this message)';

		pun_mail($pun_config['o_mailing_list'], $mail_subject, $mail_message);
	}

	// If we previously found out that the e-mail was a dupe
	if ($num_dupes && $pun_config['o_mailing_list'] != '')
	{
		while ($cur_dupe = $db->fetch_assoc($result))
			$dupe_list[] = $cur_dupe['username'];

		$mail_subject = 'Alert - Duplicate e-mail detected';
		$mail_message = 'User \''.$username.'\' registered with an e-mail address that also belongs to: '.implode(', ', $dupe_list)."\n\n".'User profile: '.$pun_config['o_base_url'].'/profile.php?id='.$new_uid."\n\n".'-- '."\n".'Forum Mailer'."\n".'(Do not reply to this message)';

		pun_mail($pun_config['o_mailing_list'], $mail_subject, $mail_message);
	}


	// Must the user verify the registration or do we log him/her in right now?
	if ($pun_config['o_regs_verify'] == '1')
	{
		// Load the "welcome" template
		$fp = fopen($pun_root.'lang/'.$language.'/mail_templates/welcome.tpl', 'r');
		$mail_tpl = trim(fread($fp, filesize($pun_root.'lang/'.$language.'/mail_templates/welcome.tpl')));
		fclose($fp);

		// The first row contains the subject
		$first_crlf = strpos($mail_tpl, "\n");
		$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
		$mail_message = trim(substr($mail_tpl, $first_crlf));

		$mail_subject = str_replace('<board_title>', $pun_config['o_board_title'], $mail_subject);
		$mail_message = str_replace('<base_url>', $pun_config['o_base_url'].'/', $mail_message);
		$mail_message = str_replace('<username>', $username, $mail_message);
		$mail_message = str_replace('<password>', $password1, $mail_message);
		$mail_message = str_replace('<login_url>', $pun_config['o_base_url'].'/login.php', $mail_message);
		$mail_message = str_replace('<board_mailer>', $pun_config['o_board_title'].' '.$lang_common['Mailer'], $mail_message);

		pun_mail($email1, $mail_subject, $mail_message);

		message($lang_register['Reg e-mail'].' <a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>.', true);
	}
	else
	{
		$expire = ($save_pass != '0') ? $now + 31536000 : 0;
		setcookie($cookie_name, serialize(array($username, $password_hash)), $expire, $cookie_path, $cookie_domain, $cookie_secure);
	}

	redirect('index.php', $lang_register['Reg complete']);
}


else
{
	$page_title = pun_htmlspecialchars($pun_config['o_board_title']).' / '.$lang_register['Register'];
	$validate_form = true;
	$element_names = array('req_username' => $lang_common['Username'], 'req_password1' => $lang_common['Password'].' 1', 'req_password2' => $lang_common['Password'].' 2', 'req_email1' => $lang_common['E-mail'].' 1', 'req_email2' => $lang_common['E-mail'].' 2');
	$form_name = 'register';
	$focus_element = 'req_username';
	require $pun_root.'header.php';

?>
<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<table class="punmain" cellspacing="1" cellpadding="4">
	<tr class="punhead">
		<td class="punhead"><?php echo $lang_common['Info'] ?></td>
	</tr>
	<tr>
		<td class="puncon2">
			<?php echo $lang_register['Desc 1'] ?><br><br>
			<?php echo $lang_register['Desc 2'] ?>
		</td>
	</tr>
</table>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>

<form method="post" action="register.php?action=register" id="register" onsubmit="return process_form(this)">
	<input type="hidden" name="form_sent" value="1">
	<table class="punmain" cellspacing="1" cellpadding="4">
		<tr class="punhead">
			<td class="punhead" colspan="2"><?php echo $lang_register['Register'] ?></td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['Username'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_register['Username info'] ?></div><br>
				&nbsp;<input type="text" name="req_username" size="25" maxlength="25">
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['Password'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">
<?php

	if ($pun_config['o_regs_verify'] == '1')
		echo "\t\t\t\t".'<div style="padding-left: 4px">'.$lang_register['Pass info 2'].'</div>'."\n";
	else
	{

?>
				<div style="padding-left: 4px"><?php echo $lang_register['Pass info 1'] ?></div><br>
				&nbsp;<input type="password" name="req_password1" size="16" maxlength="16"><br>
				&nbsp;<input type="password" name="req_password2" size="16" maxlength="16">&nbsp;&nbsp;<?php echo $lang_prof_reg['Re-enter pass'] ?>
<?php

	}

?>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><b><?php echo $lang_common['E-mail'] ?></b>&nbsp;&nbsp;</td>
			<td class="puncon2">
<?php

	if ($pun_config['o_regs_verify'] == '1')
		echo "\t\t\t\t".'<div style="padding-left: 4px">'.$lang_register['E-mail info 1'].'</div><br>'."\n\t\t\t\t".'&nbsp;<input type="text" name="req_email1" size="50" maxlength="50"><br>'."\n\n\t\t\t\t".'&nbsp;<input type="text" name="req_email2" size="50" maxlength="50">&nbsp;&nbsp;'.$lang_register['Re-enter e-mail'];
	else
		echo "\t\t\t\t".'<div style="padding-left: 4px">'.$lang_register['E-mail info 2'].'</div><br>'."\n\t\t\t\t".'&nbsp;<input type="text" name="req_email1" size="50" maxlength="50">';

?>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_prof_reg['Timezone'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_prof_reg['Timezone info'] ?></div><br>
				&nbsp;<select name="timezone">
					<option value="-12"<?php if ($pun_config['o_server_timezone'] == -12 ) echo ' selected' ?>>-12</option>
					<option value="-11"<?php if ($pun_config['o_server_timezone'] == -11) echo ' selected' ?>>-11</option>
					<option value="-10"<?php if ($pun_config['o_server_timezone'] == -10) echo ' selected' ?>>-10</option>
					<option value="-9"<?php if ($pun_config['o_server_timezone'] == -9 ) echo ' selected' ?>>-09</option>
					<option value="-8"<?php if ($pun_config['o_server_timezone'] == -8 ) echo ' selected' ?>>-08 PST</option>
					<option value="-7"<?php if ($pun_config['o_server_timezone'] == -7 ) echo ' selected' ?>>-07 MST</option>
					<option value="-6"<?php if ($pun_config['o_server_timezone'] == -6 ) echo ' selected' ?>>-06 CST</option>
					<option value="-5"<?php if ($pun_config['o_server_timezone'] == -5 ) echo ' selected' ?>>-05 EST</option>
					<option value="-4"<?php if ($pun_config['o_server_timezone'] == -4 ) echo ' selected' ?>>-04 AST</option>
					<option value="-3"<?php if ($pun_config['o_server_timezone'] == -3 ) echo ' selected' ?>>-03 ADT</option>
					<option value="-2"<?php if ($pun_config['o_server_timezone'] == -2 ) echo ' selected' ?>>-02</option>
					<option value="-1"<?php if ($pun_config['o_server_timezone'] == -1) echo ' selected' ?>>-01</option>
					<option value="0"<?php if ($pun_config['o_server_timezone'] == 0) echo ' selected' ?>>00 GMT</option>
					<option value="1"<?php if ($pun_config['o_server_timezone'] == 1) echo ' selected' ?>>+01 CET</option>
					<option value="2"<?php if ($pun_config['o_server_timezone'] == 2 ) echo ' selected' ?>>+02</option>
					<option value="3"<?php if ($pun_config['o_server_timezone'] == 3 ) echo ' selected' ?>>+03</option>
					<option value="4"<?php if ($pun_config['o_server_timezone'] == 4 ) echo ' selected' ?>>+04</option>
					<option value="5"<?php if ($pun_config['o_server_timezone'] == 5 ) echo ' selected' ?>>+05</option>
					<option value="6"<?php if ($pun_config['o_server_timezone'] == 6 ) echo ' selected' ?>>+06</option>
					<option value="7"<?php if ($pun_config['o_server_timezone'] == 7 ) echo ' selected' ?>>+07</option>
					<option value="8"<?php if ($pun_config['o_server_timezone'] == 8 ) echo ' selected' ?>>+08</option>
					<option value="9"<?php if ($pun_config['o_server_timezone'] == 9 ) echo ' selected' ?>>+09</option>
					<option value="10"<?php if ($pun_config['o_server_timezone'] == 10) echo ' selected' ?>>+10</option>
					<option value="11"<?php if ($pun_config['o_server_timezone'] == 11) echo ' selected' ?>>+11</option>
					<option value="12"<?php if ($pun_config['o_server_timezone'] == 12 ) echo ' selected' ?>>+12</option>
					<option value="13"<?php if ($pun_config['o_server_timezone'] == 13 ) echo ' selected' ?>>+13</option>
				</select>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Options'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2">
				<div style="padding-left: 4px"><?php echo $lang_prof_reg['E-mail setting info'] ?></div>
				<input type="radio" name="email_setting" value="0">&nbsp;<?php echo $lang_prof_reg['E-mail setting 1'] ?><br>
				<input type="radio" name="email_setting" value="1" checked>&nbsp;<?php echo $lang_prof_reg['E-mail setting 2'] ?><br>
				<input type="radio" name="email_setting" value="2">&nbsp;<?php echo $lang_prof_reg['E-mail setting 3'] ?><br><br>
				<div style="padding-left: 4px"><?php echo $lang_prof_reg['Save user/pass info'] ?></div>
				<input type="checkbox" name="save_pass" value="1" checked>&nbsp;<?php echo $lang_prof_reg['Save user/pass'] ?>
			</td>
		</tr>
		<tr>
			<td class="puncon1right" style="width: 140px; white-space: nowrap"><?php echo $lang_common['Actions'] ?>&nbsp;&nbsp;</td>
			<td class="puncon2"><br>&nbsp;&nbsp;<input type="submit" name="register" value="<?php echo $lang_common['Submit'] ?>">&nbsp;&nbsp;&nbsp;<a href="javascript:history.go(-1)"><?php echo $lang_common['Go back'] ?></a><br><br></td>
		</tr>
	</table>
</form>

<table class="punspacer" cellspacing="1" cellpadding="4"><tr><td>&nbsp;</td></tr></table>
<?php

	require $pun_root.'footer.php';
}
